//*****************************************
// AVR ATmega644P Geiger Counter 
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:AVR_ATmega644_Geiger.c
// KCK[JE^[@p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//@kbc͂PQWUShbgOtBbNW[gp
//    TG12864E-01XWBV or SG12864ASLB-GB-R01
//
//  PA0: LCD-R/W* for LCD
//  PA1: LCD-CS2  for LCD
//  PA2: LCD-CS1  for LCD
//  PA3: LCD-E    for LCD
//  PA4: LCD-D/I* for LCD
//  PA5: LCD-RST* for LCD
//  PA6(ADC6): Batter Monitor Max. about 1V (1V = 5V)
//  PA7(ADC7): High Volt Monitor Max. about 1V (1V = 1000V)
//
//  PB0: LCD-DB0  for LCD
//  PB1: LCD-DB1  for LCD
//  PB2: LCD-Back Light for LCD (H=ON, L=OFF)
//  PB3: RED Pulse LED(H=ON, L=OFF)
//  PB4(OC0B): Sperker Out(4kHz Signal)
//  PB5(MOSI): PS6-4pin
//  PB6(MISO): PS6-1pin
//  PB7(SCK) : PS6-3pin
//
//  PC0(SCL): TWI-SCL for RTC & SEEPROM
//  PC1(SDA): TWI-SDA for RTC & SEEPROM
//  PC2: LCD-DB2  for LCD
//  PC3: LCD-DB3  for LCD
//  PC4: LCD-DB4  for LCD
//  PC5: LCD-DB5  for LCD
//  PC6: LCD-DB6  for LCD
//  PC7: LCD-DB7  for LCD
//
//  PD0(RXD0): Serial Rxd Recieve from GPS
//  PD1(TXD0): Serial Txd Transmit to PC
//  PD2(INT0): Pulse In from RTC Square Wave Signal(1Hz,4kHz,8kHz,32kHz)
//  PD3(INT1): Geiger Myuler Pulse(Active Low)
//  PD4(OC1B): Pulse Out for High Volt Generator
//  PD5: GPS Power L:ON H:OFF
//  PD6: Tact Switch(Yellow, Active Low)
//  PD7: Tact Switch(White, Active Low)
//
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi(Ver 1.02)
//  2011/11/12 Modify for SBM-20 by  Taishi(Ver 1.02)
//  2011/11/12 Modify for J-308  by  Taishi(Ver 1.03)
//  2011/11/24 Modify for All Model  Taishi
//  2011/12/12 Modify for All Model  Taishi(Ver 1.03A) 
//             v킹̍ŏ̌NPǑɂB
//             ۑf[^MAguݒlOɂȂsCB
//             iROW̎Ak|rvAq|rv~߁AxAvɂB
//             gp̕f[^̍폜BiRgAEgj
//  2012/03/20 Modify for All Model  Taishi(Ver 1.10) 
//             ΏۃKCK[ǂ@||r^̊ZlTOOȏ̕ΏۂƂBiJ408,SI-22G,SI-21G)
//             obNCg̐ݒɂneeǉB
//             pXkdc̎gp^sgp̐ݒǉB
//             ϒľvZPȕς̌vZɂ
//             K̃pXɖȂł@POOȏ̎͐擪Ɂ
//             rddoqnlɃf[^ۑolɂAݒʂłnee^^IB
//               f[^͂SOOOƂ
//  2012/03/28 Modify for All Model  Taishi(Ver 1.11) 
//             forf[^ǉ
//             @GT-723F gpAVA|[gf[^͂B
//             @ܓxAoxAxf[^rddoqnl̕ۑf[^ɕtB
//             @forf[^t鎞̃f[^ƂĂTOOƂB
//             qsb߂iRpCXCb`܂߂āj
//  2012/03/31 Modify for All Model  Taishi(Ver 1.12) 
//             ʂ̐肕r^PԂ̈ړϒlɕύX
//             for삵ȂȂiʐMr₦j̏uǉ
//             rddoqnlۑf[^̂kbc\ǉB
//             kmcVPQΏۂɒǉ
//             PƂ̃f[^ddoqnlɕۑ鎞̎񏑍ݏꏊ̎ύX
//  2012/05/07 Modify for All Model  Taishi(Ver 1.13) 
//             	obNCgݒ肪nm̎́@Nɓ_ɂ
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/eeprom.h>
#include	<avr/sleep.h>
#include	<avr/pgmspace.h>

#include	"AVR_ATmega644_Geiger.h"
#include	"Serial.h"
#include	"Comm1.h"
#include	"LCD.h"
#include	"Display.h"
#include	"Setting.h"
#include	"EEPROM.h"
#include	"Utility.h"
#include	"Timer.h"
#include	"Ad_conv.h"
#include	"Pulse.h"
#include	"Rtc.h"
#include	"Seeprom.h"
#include	"Graph.h"
#include	"Mega_Twi.h"
#include	"Const_str.h"
#include	"Setting.h"
#include	"Save_Dt.h"
#include	"Gps.h"

unsigned char	pulse_led_on;					// pXkdcgp 1:gpA 0:sgp
unsigned char	buz_on;							// uU[gp 1:gpA 0:sgp
unsigned char	hv_uSv_disp;					// gudAr\ 2:uSv+uSv, 1:HV+cpm, 0:cph+cpm
unsigned int	old_count_minute;				// OPԖ̃JEg
unsigned char	in_hv_adja;						// 0:guLĂA1:guLĂȂi킹ݒj
unsigned char	back_light_mode;				// obNCg̏^_[hiOFneeAPF`tsnAQFnm)
unsigned char	tim_1minute;					// 
unsigned char	tim_1hour;						// 

unsigned long	count_day[N_of_DAY_DATA];
unsigned long	count_hour[N_of_HOUR_DATA];
unsigned int	count_minute[N_of_MINUTE_DATA];
unsigned char	cpd_data_pos;
unsigned char	cph_data_pos;
unsigned char	cpm_data_pos;
unsigned int	cpm_to_uSv_spn;					// cpm_to_uSv_spn Zl̂PO{(1000:100.0)
unsigned int	cpm_to_uSv_ofs;					// cpm_to_uSv_ofs ZItZbg(JEgl炱̒l)
unsigned char	non_seep = 0;
unsigned char	tim_1s_a;						// PbPʃ^C}[
unsigned char	tim_1s_back_light;				// obNCgpPbPʃ^C}[
unsigned char	seep_save_mode;					// rddoqnlɕۑ郂[h(0:, 1:cpm, 2:cph, 3:cpd)
unsigned char	seep_gps_enable;				// rddoqnlɕۑforL^(0:, 1:L)
unsigned int	count_sec[60];					// PԂ̈ړς߂ׂ̂PbԂ̃JEg
unsigned char	count_sec_pos;					// Pb̒lꏊ
unsigned char	count_sec_full;					// 1=Pb̒lSĖ܂

#ifdef		TWI_DEBUG_ENABLE
//*****************************************
// svhM̏ԕ\
//   y:\ʒuixj0--7
//         ̍sRsɕ\
//  ߂̒lU܂őkf[^\
//*****************************************
void	disp_twi_transmit_data(unsigned char y)
{
	unsigned char	twidata[16];
	unsigned char	i;

	disp_lcd_G( 0, y+0, (unsigned char *)"WD ");	// display Dot Matrix LCD
	twi_debug_Load_WriteData(&twidata[0]);
	for(i=0;i<6;i++){
		wtod_02x((char *)disp_moji, twidata[i]);	// svhőf[^
		disp_lcd_G( i*3+3, y+0, &disp_moji[0]);		// display Dot Matrix LCD
	}

	disp_lcd_G( 0, y+1, (unsigned char *)"WS ");	// display Dot Matrix LCD
	twi_debug_Load_WStatData(&twidata[0]);
	for(i=0;i<6;i++){
		wtod_02x((char *)disp_moji, twidata[i]);	// svhő̏
		disp_lcd_G( i*3+3, y+1, &disp_moji[0]);		// display Dot Matrix LCD
	}

	disp_lcd_G( 0, y+2, (unsigned char *)"RD ");	// display Dot Matrix LCD
	twi_debug_Load_ReadData(&twidata[0]);
	for(i=0;i<6;i++){
		wtod_02x((char *)disp_moji, twidata[i]);	// svhœǂ񂾃f[^
		disp_lcd_G( i*3+3, y+2, &disp_moji[0]);		// display Dot Matrix LCD
	}

}
#endif		//TWI_DEBUG_ENABLE
//*****************************************
// qsbG[
//  PB3: RED LED(H=ON, L=OFF)
//  ʏ͂ŏI邪A̃XCb`ꍇ͔
//*****************************************
void	rtc_error(unsigned char d)
{
#ifdef	_SIMURATION_					// V~[V̎
		;
#else	//_SIMURATION_
 #ifdef		TWI_DEBUG_ENABLE
	unsigned char	uc0;
	unsigned char	uc1;
	unsigned char	uc2;
 #endif		//TWI_DEBUG_ENABLE

	disp_lcd_G( 0, 0,(unsigned char *)"rtc_init Error !!");	// \
	wtod_2u((char *)disp_moji, d);							// G[
	disp_lcd_G( 0, 1, &disp_moji[0]);						// display Dot Matrix LCD Down Side
	wtod_02x((char *)disp_moji, gTwi_status);				// G[
	disp_lcd_G( 5, 1, &disp_moji[0]);						// display Dot Matrix LCD Down Side
	disp_one_char_lcd_G( 7, 1, 'h');						// 'h'

	DDRB |= (1 << DDB3);									// Port-B Bit3 : Output
 #ifdef		TWI_DEBUG_ENABLE
	disp_twi_transmit_data(3);								// svhM̏ԕ\

	cli();
	uc0 = 0;
	uc1 = 0;
	uc2 = 0;

	for(;;){
		uc0 = (~PIND & (SW_LEFT | SW_RIGHT));
		PORTB |=  (1 << PB3);
		delay_ms(100);												// 200mS Delay
		uc1 = (~PIND & (SW_LEFT | SW_RIGHT));
		PORTB &= ~(1 << PB3);
		delay_ms(500);												// 200mS Delay
		uc2 = (~PIND & (SW_LEFT | SW_RIGHT));
		if( (uc0 == (SW_LEFT | SW_RIGHT)) && (uc2 == (SW_LEFT | SW_RIGHT)) && (uc2 == (SW_LEFT | SW_RIGHT)) ){		// ̃XCb`ꑱ
			break;
		}
	}
 #else	//TWI_DEBUG_ENABLE
	delay_ms(2000);
 #endif		//TWI_DEBUG_ENABLE

	DDRB &= ~(1 << DDB3);											// Port-B Bit3 : Output

#endif	//_SIMURATION_
}

//*****************************************
// rdddoG[isvhANZXj
//  PB3: RED LED(H=ON, L=OFF)
//  ʏ͂ŏI邪A̃XCb`ꍇ͔
//*****************************************
void	seep_error1(unsigned char d)
{
#ifdef	_SIMURATION_					// V~[V̎
		;
#else	//_SIMURATION_
 #ifdef		TWI_DEBUG_ENABLE
	unsigned char	uc0;
	unsigned char	uc1;
	unsigned char	uc2;
 #endif		//TWI_DEBUG_ENABLE

	disp_lcd_G( 0, 0,(unsigned char *)"seep.(TWI) Error !!");	// \
	wtod_2u((char *)disp_moji, d);							// G[
	disp_lcd_G( 0, 1, &disp_moji[0]);						// display Dot Matrix LCD Down Side
	wtod_02x((char *)disp_moji, gTwi_status);				// G[
	disp_lcd_G( 5, 1, &disp_moji[0]);						// display Dot Matrix LCD Down Side
	disp_one_char_lcd_G( 7, 1, 'h');						// 'h'

	DDRB |= (1 << DDB3);									// Port-B Bit3 : Output
 #ifdef		TWI_DEBUG_ENABLE
	disp_twi_transmit_data(3);								// svhM̏ԕ\


	cli();
	uc0 = 0;
	uc1 = 0;
	uc2 = 0;

	for(;;){
		uc0 = (~PIND & (SW_LEFT | SW_RIGHT));
		PORTB |=  (1 << PB3);
		delay_ms(100);												// 200mS Delay
		uc1 = (~PIND & (SW_LEFT | SW_RIGHT));
		PORTB &= ~(1 << PB3);
		delay_ms(500);												// 200mS Delay
		uc2 = (~PIND & (SW_LEFT | SW_RIGHT));
		if( (uc0 == (SW_LEFT | SW_RIGHT)) && (uc2 == (SW_LEFT | SW_RIGHT)) && (uc2 == (SW_LEFT | SW_RIGHT)) ){		// ̃XCb`ꑱ
			non_seep = 1;
			break;
		}
	}
 #else	//TWI_DEBUG_ENABLE
	non_seep = 1;
	delay_ms(2000);
 #endif		//TWI_DEBUG_ENABLE

	DDRB &= ~(1 << DDB3);											// Port-B Bit3 : Output

#endif	//_SIMURATION_
}

//*****************************************
// VAddoqnlG[
//  PB3: RED LED(H=ON, L=OFF)
//  ʏ͂ŏI邪A̃XCb`ꍇ͔
//*****************************************
void	seep_error2(unsigned char dw, unsigned char dr)
{
#ifdef	_SIMURATION_					// V~[V̎
		;
#else	//_SIMURATION_
 #ifdef		TWI_DEBUG_ENABLE
	unsigned char	uc0;
	unsigned char	uc1;
	unsigned char	uc2;
 #endif		//TWI_DEBUG_ENABLE

	disp_lcd_G( 0, 0,(unsigned char *)"Seeprom Error !!");	// \
	disp_lcd_G( 0, 1,(unsigned char *)"Writ ");				// \
	wtod_02x((char *)disp_moji, dw);						// G[
	disp_lcd_G( 5, 1, &disp_moji[0]);						// display Dot Matrix LCD Down Side
	disp_lcd_G( 7, 1,(unsigned char *)"h !=");				// \
	wtod_02x((char *)disp_moji, dr);						// G[
	disp_lcd_G(12, 1, &disp_moji[0]);						// display Dot Matrix LCD Down Side
	disp_lcd_G(14, 1,(unsigned char *)"h Read");			// \

	DDRB |= (1 << DDB3);									// Port-B Bit3 : Output
 #ifdef		TWI_DEBUG_ENABLE

	uc0 = 0;
	uc1 = 0;
	uc2 = 0;

	for(;;){
		uc0 = (~PIND & (SW_LEFT | SW_RIGHT));
		PORTB |=  (1 << PB3);
		delay_ms(100);												// 100mS Delay
		uc1 = (~PIND & (SW_LEFT | SW_RIGHT));
		PORTB &= ~(1 << PB3);
		delay_ms(500);												// 100mS Delay
		uc2 = (~PIND & (SW_LEFT | SW_RIGHT));
		if( (uc0 == (SW_LEFT | SW_RIGHT)) && (uc2 == (SW_LEFT | SW_RIGHT)) && (uc2 == (SW_LEFT | SW_RIGHT)) ){		// ̃XCb`ꑱ
			break;
		}
	}
 #else	//TWI_DEBUG_ENABLE
	non_seep = 1;
	delay_ms(2000);
 #endif		//TWI_DEBUG_ENABLE

	DDRB &= ~(1 << DDB3);											// Port-B Bit3 : Output

#endif	//_SIMURATION_
}



// **********************************************************
// ******************** r^Zl ********************
// **********************************************************
//unsigned char	ave_data_pos = 0;			// xۑf[^̈ʒu
//unsigned int	ave_data[0x40];				// P̃f[^US
//*****************************************
// rZ\iPԂ̃JEgPԂ̃JEgɂj
//  F\ʒu(0-->15)
//  Fs\ʒu(0-->1)
//  FJEgli@́@j
//  QF1:PԒl@́@0:PԒl
//  QFPʕ\(uSv/h) 1:LA 0:
//*****************************************
void	disp_uSv_at_count(unsigned char x, unsigned char y, unsigned long cp, unsigned char minute_data, unsigned char unit_ari)
{
	unsigned long	ul;

	get_pgm_str(&str_space10[0]);							// vÖ̕("      ")擾
	disp_lcd_G(x,y,&disp_moji[9]);							// \
	if((cp == 0xffff)&&(minute_data == 1)){					// f[^
		get_pgm_str(&str_5minus[0]);						// vÖ̕("----")擾
		disp_lcd_G(x,y,&disp_moji[1]);					// \
	}else if(cp == 0xffffffff){								// f[^
		get_pgm_str(&str_5minus[0]);						// vÖ̕("----")擾
		disp_lcd_G(x,y,&disp_moji[1]);					// \
	}else{
		if(minute_data == 1){								// f[^̎
			if(cp <= (unsigned long)cpm_to_uSv_ofs){		// lJEgl
				cp = (unsigned long)0;
			}else{
				cp -= (unsigned long)cpm_to_uSv_ofs;		// JEgl
			}
			ul = (((unsigned long)cp * (unsigned long)1000) / (unsigned long)cpm_to_uSv_spn);	// 0.01PʂuSv
		}else{												// f[^̎
			if(cp <= ((unsigned long)cpm_to_uSv_ofs * (unsigned long)60)){				// lJEgl
				cp = 0;
			}else{
				cp -= ((unsigned long)cpm_to_uSv_ofs * (unsigned long)60);				// JEgl
			}
			ul = (((unsigned long)cp * (unsigned long)1000) / ((unsigned long)cpm_to_uSv_spn * (unsigned long)60));	// 0.01PʂuSv
		}
		if((unsigned long)999999 < ul){
			ul = (unsigned long)999999;
		}
		if(ul <= 999){										// 9.99 ȉ(00999)
			wtod_05u((char *)disp_moji,(unsigned int)ul);	// ɂ
			disp_moji[6] = disp_moji[5];
			disp_moji[5] = disp_moji[4];
			disp_moji[4] = disp_moji[3];
			disp_moji[3] = '.';
			disp_lcd_G(x, y, &disp_moji[2]);				// display Dot Matrix LCD Up or Down Side
		}else if(ul <= 9999){								// 99.9 ȉ(09999)
			wtod_05u((char *)disp_moji,(unsigned int)ul);	// ɂ
			disp_moji[4] = disp_moji[3];
			disp_moji[3] = '.';
			if(disp_moji[1] == '0'){
				disp_moji[1] = ' ';
			}
			disp_lcd_G(x, y, &disp_moji[1]);				// display Dot Matrix LCD Up or Down Side
		}else{												// (999999)
			wtod_5u((char *)disp_moji,(unsigned int)(ul / (unsigned int)100));	// _ŕɂ
			disp_lcd_G(x, y, &disp_moji[1]);				// display Dot Matrix LCD Up or Down Side
		}
	}

	if(unit_ari == 1){										// Pʕ\(uSv/h) LɎ
		get_pgm_str(&str_uSv[0]);							// vÖ̕("uSv")擾
		disp_lcd_G(x+5,y,disp_moji);						// \
		get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
		disp_lcd_G(x+8,y,disp_moji);						// \
	}
}
//*****************************************
// rZ̎擾iPԂ̃JEgPԂ̃JEgɂj
//  FJEgli@́@j
//  QF1:PԒl@́@0:PԒl
//   disp_moji[] ɓ
//*****************************************
void	get_uSv_at_count(unsigned long cp, unsigned char minute_data)
{
	unsigned long	ul;
	char			mm[21];

	if((cp == 0xffff)&&(minute_data == 1)){					// f[^
		get_pgm_str(&str_5minus[0]);						// vÖ̕("----")擾
		llstrcpy(mm,(char *)(&disp_moji[1]));
		llstrcpy((char *)(disp_moji), mm);
	}else if(cp == 0xffffffff){								// f[^
		get_pgm_str(&str_5minus[0]);						// vÖ̕("----")擾
		llstrcpy(mm,(char *)(&disp_moji[1]));
		llstrcpy((char *)(disp_moji), mm);
	}else{
		if(minute_data == 1){								// f[^̎
			if(cp <= (unsigned long)cpm_to_uSv_ofs){		// lJEgl
				cp = (unsigned long)0;
			}else{
				cp -= (unsigned long)cpm_to_uSv_ofs;		// JEgl
			}
			ul = (((unsigned long)cp * (unsigned long)1000) / (unsigned long)cpm_to_uSv_spn);	// 0.01PʂuSv
		}else{												// f[^̎
			if(cp <= ((unsigned long)cpm_to_uSv_ofs * (unsigned long)60)){				// lJEgl
				cp = 0;
			}else{
				cp -= ((unsigned long)cpm_to_uSv_ofs * (unsigned long)60);				// JEgl
			}
			ul = (((unsigned long)cp * (unsigned long)1000) / ((unsigned long)cpm_to_uSv_spn * (unsigned long)60));	// 0.01PʂuSv
		}
		if((unsigned long)999999 < ul){
			ul = (unsigned long)999999;
		}
		if(ul <= 999){										// 9.99 ȉ(00999)
			wtod_05u((char *)disp_moji,(unsigned int)ul);	// ɂ
			disp_moji[6] = disp_moji[5];
			disp_moji[5] = disp_moji[4];
			disp_moji[4] = disp_moji[3];
			disp_moji[3] = '.';
			llstrcpy(mm,(char *)(&disp_moji[2]));
			llstrcpy((char *)(disp_moji), mm);
		}else if(ul <= 9999){								// 99.9 ȉ(09999)
			wtod_05u((char *)disp_moji,(unsigned int)ul);	// ɂ
			disp_moji[4] = disp_moji[3];
			disp_moji[3] = '.';
			if(disp_moji[1] == '0'){
				disp_moji[1] = ' ';
			}
			llstrcpy(mm,(char *)(&disp_moji[1]));
			llstrcpy((char *)(disp_moji), mm);
		}else{												// (999999)
			wtod_5u((char *)disp_moji,(unsigned int)(ul / (unsigned int)100));	// _ŕɂ
			llstrcpy(mm,(char *)(&disp_moji[1]));
			llstrcpy((char *)(disp_moji), mm);
		}
	}
}

//*****************************************
// Q̃XCb`Q@܂ŉiv[v
//  XCb`rbǵA`^Op^C}[Ɂ@荞݂͎gȂ
//  \tgEFA^C}[gp
//*****************************************
void	wait_sw_off(void)
{
	while(1){
		if((PIND & (SW_LEFT | SW_RIGHT)) == (SW_LEFT | SW_RIGHT)){
			delay_ms(100);												// 100mS Delay
			if((PIND & (SW_LEFT | SW_RIGHT)) == (SW_LEFT | SW_RIGHT)){
				break;													// {ɗꂽƂ
			}
		}
	}
}

//*****************************************
// obNCĝnm^nees
//*****************************************
void	proc_back_light(void)
{
	if(back_light_mode == 2){				// obNCg_[h̎
		back_light(1);						// obNCg_
	}else if(back_light_mode == 1){			// obNCg_ij[h̎
		if(tim_1s_back_light != 0){			// obNCgp^C}[OłȂ
			back_light(1);					// obNCg_
		}else{
			back_light(0);					// obNCg
		}
	}else{									// obNCg[h̎
		back_light(0);						// obNCg
	}
}
//*****************************************
// obNCg̎nmX^[gs
//*****************************************
void	start_back_light(void)
{
	if(back_light_mode == 1){						// obNCg_ij[h̎
		tim_1s_back_light = TIM_BACK_LIGHT_ON;		// obNCgp^C}[Zbg
	}
}
//*****************************************
// Q̃XCb`Q@܂ŉiv[v
//  XCb`͂Ɋ荞݃^C}[gB
//*****************************************
void	wait_key_off(void)
{
	while(1){											// ̂rv܂ő҂
		get_sw();										//@XCb`Ԃ
		if( (sw[1] & (SW_LEFT | SW_RIGHT)) == 0 ){		// ꂽ
			delay_ms(100);								// 100mS Delay
			get_sw();									//@XCb`Ԃœ
			if( (sw[1] & (SW_LEFT | SW_RIGHT)) == 0 ){	// ꂽ
				break;
			}
		}
	}
}
//*****************************************
// guj^l(Volt)̎擾
//  Qɓ
//*****************************************
void	get_hv_moni(void)
{
	unsigned int	ui;

	ui = ad7_get_data();									// A/D 7 Get A/D data
	hv_moni = (unsigned int)(((unsigned long)ui * (unsigned long)hv_hosei_spn)/(unsigned long)1000 - HV_HOSEI_OFS_DEFAULT + hv_hosei_ofs);
}
//*****************************************
// gupo͒l̕\
//*****************************************
void	disp_hv_out(unsigned char x, unsigned char y)
{
	wtod_5u((char *)disp_moji,hv_out);						// High Volt Data
	disp_lcd_G(x, y, &disp_moji[2]);							// display Dot Matrix LCD Up or Down Side
}
//*****************************************
// obej^l(Volt)̎擾
//  Qɓ
//*****************************************
void	get_bat_moni(void)
{
	unsigned int	ui;

	ui = ad6_get_data();									// A/D 6 Get A/D data
	bat_moni = (unsigned int)(((unsigned long)ui * (unsigned long)610) / (unsigned long)1024);
}
//*****************************************
// obej^l̕\
//*****************************************
void	disp_bat_moni(unsigned char x, unsigned char y)
{
	get_bat_moni();											// obej^l(Volt)̎擾(bat_moni ɓ)
	wtod_5u((char *)disp_moji,bat_moni);					// battry Volt Data
	disp_moji[1] = disp_moji[2];
	disp_moji[2] = '.';
	disp_lcd_G(x, y, &disp_moji[1]);						// display Dot Matrix LCD Up or Down Side
}


//*****************************************
// rZl̏
// @荞ݕsŌĂԂ
//*****************************************
void	init_cpm_to_uSv(void)
{
	unsigned char	i;
	unsigned int	i_dim[3];

	// ZlXp
	for(i=0;i<3;i++){
		eeprom_busy_wait();
		i_dim[i] = eeprom_read_word(&eep_cpm_to_uSv_spn[i]);			// rZl
	}

	cpm_to_uSv_spn = tasuuketu_ui(i_dim[0], i_dim[1], i_dim[2], CPM_uSv_h_SPN_DEFAULT);	// 

	if(9999 < cpm_to_uSv_spn){
		cpm_to_uSv_spn = CPM_uSv_h_SPN_DEFAULT;							// 400.0
	}else if(cpm_to_uSv_spn == 0){
		cpm_to_uSv_spn = 1;												// 0.1
	}

	for(i=0;i<3;i++){
		if(cpm_to_uSv_spn != i_dim[i]){
			eeprom_busy_wait();
			eeprom_write_word(&eep_cpm_to_uSv_spn[i],cpm_to_uSv_spn);	// rZl̕ۑ
		}
		eeprom_busy_wait();
	}


	// ZlItZbgilj
	for(i=0;i<3;i++){
		eeprom_busy_wait();
		i_dim[i] = eeprom_read_word(&eep_cpm_to_uSv_ofs[i]);			// rZl
	}

	cpm_to_uSv_ofs = tasuuketu_ui(i_dim[0], i_dim[1], i_dim[2], CPM_uSv_h_OFS_DEFAULT);		// 

	if(100 < cpm_to_uSv_ofs){
		cpm_to_uSv_ofs = CPM_uSv_h_OFS_DEFAULT;							// 0
	}

	for(i=0;i<3;i++){
		if(cpm_to_uSv_ofs != i_dim[i]){
			eeprom_busy_wait();
			eeprom_write_word(&eep_cpm_to_uSv_ofs[i],cpm_to_uSv_ofs);	// rZl̕ۑ
		}
		eeprom_busy_wait();
	}

}

//*****************************************
// gupo͒l̒
//*****************************************
void	adj_hv_out(void)
{
	int	sa;

	sa = (int)hv_target_volt - (int)hv_moni;

	if((sa <= 1)&&(-1 <= sa)){		// Ă镨Ƃ
		in_hv_adja = 0;
	}else if(sa <= -10){
		hv_out -= 10;
		in_hv_adja = 1;
	}else if(sa < -1){
		hv_out += sa;
		in_hv_adja = 1;
	}else if(10 <= sa){
		hv_out += 10;
		in_hv_adja = 1;
	}else if(1 < sa){
		hv_out += sa;
		in_hv_adja = 1;
	}

	if(HV_OUT_COUNT_MAX < hv_out){	// HV_OUT_COUNT_MAXłƂ߂iTOOu{j
		hv_out = HV_OUT_COUNT_MAX;
	}

	if(in_hv_adja == 1){
		set_Timer1_ontime();		// Set Timer1 ON Time
	}
}


//*****************************************
// f[^̏ݒ
//*****************************************
static	void	meas_data_init(void)
{

	for(cpm_data_pos=0; cpm_data_pos < N_of_MINUTE_DATA; cpm_data_pos++){
		count_minute[cpm_data_pos] = 0xffff;
	}
	cpm_data_pos=0;

	for(cph_data_pos=0; cph_data_pos < N_of_HOUR_DATA; cph_data_pos++){
		count_hour[cph_data_pos] = 0xffffffff;
	}
	cph_data_pos=0;

	for(cpd_data_pos=0; cpd_data_pos < N_of_DAY_DATA; cpd_data_pos++){
		count_day[cpd_data_pos] = 0xffffffff;
	}
	cpd_data_pos=0;

}
//*****************************************
// Pbo߂̏
//  Pbo߂ƌF́@rtc_1s_flg != 0 ŁA
//*****************************************
void	proc_1sec_passage(unsigned char init)
{
	if(init == 1){											// 
		tim_1s_a = 60;										// PbPʃ^C}[
		tim_1s_back_light = 0;								// obNCgpPbPʃ^C}[
		rtc_1s_flg = 0;
	}else{													// 쎞
		while(rtc_1s_flg != 0){
			if(tim_1s_a != 0){
				tim_1s_a--;									// PbPʃ^C}[@|P
			}
			rtc_1s_flg--;
		}
	}
}
//*****************************************
// Main
//*****************************************
int	main(void)
{
	unsigned int	befor_count_minute;							// OJEg
	unsigned int	old_count_endless;							// ÕGhX̃JE^[
	unsigned int	i;
	unsigned char	for_sec_old_tim_1s_a;						// blׂ̈̑Ob
	unsigned char	old_tim_1s_a;								// Ob
	unsigned char	j;
	unsigned char	old_hv_uSv_disp;
	unsigned char	disp_item = 0;
	unsigned char	disp_any_condition = 0;
	unsigned char	battry_blink=0;
	unsigned char	r;
	unsigned char	uc;
	unsigned char	old_pos;
	unsigned char	seep_first=1;
	unsigned char	dw;
	unsigned char	dr;
	unsigned char	gpe;
	unsigned char	ssm;

	delay_ms(500);												// 500mS Delay

	led_init();
	sw_init();
	DEBUG_sig_init();

#ifdef	CHECK_SW_LED_SERIAL
// ------ kdcƃXCb`̓`FbN@n ------
//  PB3: RED LED(H=ON, L=OFF)
//  PD6: Tact Switch(Yellow)
//  PD7: Tact Switch(White)
//
// -------------------------------------
//@kdĉODTbnmAODTbneeUOJԂ
//@@ǂꂩ̃XCb`ꂽkdc_铮Ł@iv[v
//
//@@vOƌ`FbN
//@@_Ŏ𑪂ė\̓gł鎖mF˂
// -------------------------------------
	delay_ms(500);												// 500mS Delay
	{
#define	LED_BLINK_COUNT	10										//  kdc̓_Ő

		unsigned char	i;

		DDRB |= (1 << DDB3);										// Port-B Bit3 : Output

		for(i=0;i<LED_BLINK_COUNT;i++){
			PORTB |= (1 << PB3);									// LED ON
			delay_ms(500);											// 500mS Delay
			PORTB &= ~(1 << PB3);									// LED OFF
			delay_ms(500);											// 500mS Delay
		}

		DDRD &= ~( (1 << DDD6) | (1 << DDD7) );						// Port-D Bit6,7 : Intput
		PORTD |= ( (1 << PD6) | (1 << PD7) );						// Port-D Bit6,7 : Pullup

		for(;;){
			if( ((~PIND & (1 << PIND6)) != 0)&&((~PIND & (1 << PIND7)) != 0) ){		// ]ăXCb`f[^擾@QƂĂ
				break;
			}else if( (~PIND & (1 << PIND6)) != 0){					// ]ăXCb`f[^擾
				PORTB |= (1 << PB3);								// LED ON
			}else if( (~PIND & (1 << PIND7)) != 0){					// ]ăXCb`f[^擾
				PORTB |= (1 << PB3);								// LED ON
			}else{
				PORTB &= ~(1 << PB3);								// LED OFF
			}
		}
	}
// ------ kdcƃXCb`̓`FbN@I ------

// ------ VAʐM̓`FbN@n ------
//
	uart0_pre_init();											// UART Pre_Initial

	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);
	tx0_str(disp_moji);

	get_pgm_str(&str_title_1[0]);								// vÖ̕(TITLE1)擾
	tx0_str(disp_moji);

	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_title_2[0]);								// vÖ̕ o[W擾
	tx0_str(disp_moji);

	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_date[0]);									// vÖ̕(N)擾
	tx0_str(disp_moji);

	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_time[0]);									// vÖ̕()擾
	tx0_str(disp_moji);

	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_echo_check[0]);							// vÖ̕("Echo Rec + 1")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_echo_E[0]);								// vÖ̕(" Rec=E --> END")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);

	for(;;){
		if(rx0_char() != 0){									// Mf[^L̎
			tx0_char((unsigned char)((uart0_err_receiver + 1)&0xff));	// M
			if ((uart0_err_receiver & 0xff) == 'E'){			// fdfM̎
				break;
			}
		}
	}
	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_echo_end[0]);								// vÖ̕("Echo Check End")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);

// ------ VAʐM̓`FbN@I ------
#endif	//CHECK_SW_LED_SERIAL

#ifdef	CHECK_FONT
// ****************** Font Check Start ******************
	uart0_pre_init();											// UART Pre_Initial
	DDRD &= ~( (1 << DDD6) | (1 << DDD7) );						// Port-D Bit6,7 : Intput
	PORTD |= ( (1 << PD6) | (1 << PD7) );						// Port-D Bit6,7 : Pullup
	tx0_str((unsigned char *)("Font Check Start\r\n"));
	init_lcd_G();

	for(;;){
		disp_clear_lcd_G();
		disp_lcd_G_font_check1();
		for(;;){
			if(((~PIND) & (1 << PD7)) != 0){					// ]ăXCb`f[^擾
				delay_ms(30);									// 30mS Delay
				if(((~PIND) & (1 << PD7)) != 0){				// ]ăXCb`f[^擾
					break;
				}
			}
		}
		for(;;){
			if(((~PIND) & (1 << PD7)) == 0){					// ]ăXCb`f[^擾
				delay_ms(30);									// 30mS Delay
				if(((~PIND) & (1 << PD7)) == 0){				// ]ăXCb`f[^擾
					break;
				}
			}
		}

		disp_clear_lcd_G();
		disp_lcd_G_font_check2();
		for(;;){
			if(((~PIND) & (1 << PD7)) != 0){					// ]ăXCb`f[^擾
				delay_ms(30);									// 30mS Delay
				if(((~PIND) & (1 << PD7)) != 0){				// ]ăXCb`f[^擾
					break;
				}
			}
		}
		for(;;){
			if(((~PIND) & (1 << PD7)) == 0){					// ]ăXCb`f[^擾
				delay_ms(30);									// 30mS Delay
				if(((~PIND) & (1 << PD7)) == 0){				// ]ăXCb`f[^擾
					break;
				}
			}
		}
	}
// ****************** Font Check End ********************
#endif	//CHECK_FONT



#ifdef	CHECK_BUZZER
// ****************** BUZZER Check Start ********************
	Timer0_init();
	buz2_on_off(1);
	delay_ms(500);												// 500mS Delay
	buz2_on_off(0);
	delay_ms(500);												// 500mS Delay
	buz2_on_off(1);
	delay_ms(500);												// 500mS Delay
	buz2_on_off(0);
	delay_ms(500);												// 500mS Delay
// ****************** BUZZER Check End ********************
#endif	//CHECK_BUZZER



#ifdef	CHECK_LCD
// ------ kbc̓`FbN@n ------
//
	get_pgm_str(&str_lcd_chk_start[0]);							// vÖ̕("LCD check start")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);

	init_lcd_G();
	disp_clear_lcd_G();


	get_pgm_str(&str_title_1[0]);								// vÖ̕(TITLE1)擾
	disp_lcd_G(0,0,disp_moji);									// \
	get_pgm_str(&str_title_2[0]);								// vÖ̕ o[W擾
	disp_lcd_G(2,1,disp_moji);									// \
	get_pgm_str(&str_date[0]);									// vÖ̕(N)擾
	disp_lcd_G(0,2,disp_moji);									// \
	get_pgm_str(&str_time[0]);									// vÖ̕()擾
	disp_lcd_G(0,3,disp_moji);									// \

	for(;;){
		back_light(1);
		PORTB |= (1 << PB3);									// LED ON
		delay_ms(1000);											// 1000mS Delay
		back_light(0);
		PORTB &= ~(1 << PB3);									// LED OFF
		delay_ms(1000);											// 1000mS Delay
	}

//
// ------ kbc̓`FbN@I ------
#endif	//CHECK_LCD


	delay_ms(200);												// 200mS Delay


#ifdef		DEBUG_TX
	uart0_pre_init();											// UART Pre_Initial
	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);
	tx0_str(disp_moji);

	get_pgm_str(&str_title_1[0]);								// vÖ̕(TITLE1)擾
	tx0_str(disp_moji);

	get_pgm_str(&str_title_2[0]);								// vÖ̕ o[W擾
	tx0_str(disp_moji);

	get_pgm_str(&str_date[0]);									// vÖ̕(N)擾
	tx0_str(disp_moji);

	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_time[0]);									// vÖ̕()擾
	tx0_str(disp_moji);

	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);
#endif		//DEBUG_TX


	// LED
	led_on();													// LED ON
	delay_ms(500);												// 500mS Delay
	led_off();													// LED OFF

	Timer0_init();												// Timer0 Initial(for Buzzer2)
	// Buzzer
	buz2_on_off(1);												// Buzzer2 ON
	delay_ms(500);												// 500mS Delay
	buz2_on_off(0);												// Buzzer2 OFF

	uart0_pre_init();											// UART Pre_Initial
	init_lcd_G();
	disp_clear_lcd_G();
	load_back_light_mode();										// obNCg[h̓ǂݏo
	proc_back_light();											// obNCĝnm^nees

	// Title
	get_pgm_str(&str_title_1[0]);								// vÖ̕(TITLE1)擾
	disp_lcd_G(0, 0, disp_moji);								// display Dot Matrix LCD Up Side
	get_pgm_str(&str_title_2[0]);								// vÖ̕ o[W擾
	disp_lcd_G(0, 1, disp_moji);								// display Dot Matrix LCD Down Side
	tx_title();													// ^CgAo[WM

	get_pgm_str(&str_date[0]);									// vÖ̕(N)擾
	disp_lcd_G(0,6,disp_moji);									// \
	get_pgm_str(&str_time[0]);									// vÖ̕()擾
	disp_lcd_G(0,7,disp_moji);									// \
	tx_make_data();												// vO쐬NM

	delay_ms(2000);												// 2000mS Delay
	disp_clear_lcd_G();											// Clear Display

// POPU̕\
//	disp_lcd_10x16_G(0, 0, (unsigned char *)"0.12");
//	disp_lcd_10x16_G(4, 1, (unsigned char *)"3/45");
//	disp_lcd_10x16_G(6, 2, (unsigned char *)"6:78");
//	disp_lcd_10x16_G(5, 3, (unsigned char *)"9" "\01\02");
//	delay_ms(4000);												// 2000mS Delay
//	disp_clear_lcd_G();											// Clear Display


	load_seep_save_mode();										// rddoqnlɕۑ郂[h̓ǂݏo
	load_buz_on_off();											// uU[ nm^nee̓ǂݏo
	load_pulse_led_on_off();									// pXkdc nm^nee̓ǂݏo
	ad67_init();												// A/D 6&7 Initial
	init_cpm_to_uSv();											// rZl̏
	load_seep_gps_enable();										// rddoqnlɕۑfor[h̓ǂݏo
	set_cpm_write_pos();										// ꕪƃf[^̍x݈̏ʒuݒ肷

	r = rtc_init();												//  qsb̏ݒ
	if(r != 0){
		rtc_error(r);
		disp_clear_lcd_G();										// Clear Display
	}


	r = rtc_read();												// RTC ǂݏo
	if(r != 0){
		rtc_error(r);
		disp_clear_lcd_G();										// Clear Display
	}

	if((gRTC_sec & 0x80)!= 0){									// qsb̓d
		r = proc_set_rtc();										// v킹
		if(r != 0){
			rtc_error(r);
		}
		disp_clear_lcd_G();										// Clear Display
	}

	DEBUG_sig_on();
	r = seep_read_1(0x7fff, &dw);								// Serial EEPROM Read
	if(r != 0){
		seep_error1(r);
		disp_clear_lcd_G();										// Clear Display
	}
	dw++;
	r = seep_write_1(0x7fff, &dw);								// Serial EEPROM Read
	if(r != 0){
		seep_error1(r);
		disp_clear_lcd_G();										// Clear Display
	}
	r = seep_read_1(0x7fff, &dr);								// Serial EEPROM Read
	if(r != 0){
		seep_error1(r);
		disp_clear_lcd_G();										// Clear Display
	}
	if(dw != dr){
		seep_error2(dw, dr);
		disp_clear_lcd_G();										// Clear Display
	}
	set_seep_write_pos();										// rddoۑf[^̍x݈̏ʒuݒ肷


// ---- DEBUG ----
//	wtod_05u((char *)(&disp_moji[0]), seep_write_pos);	// x̕ۑꏊԍ
//	uart0_tx_str_crlf((char *)&disp_moji[0]);	// UART TxD String + CR + LF
// ---- DEBUG ----

	graph_init();												// Ot ݒ

	if( (PIND & (SW_LEFT | SW_RIGHT)) == 0 ){					// Left SW & Right SW nm
		delay_ms(100);											// 100mS Delay
		if((PIND & (SW_LEFT | SW_RIGHT)) == 0){					// Left SW & Right SW nm
			proc_select_hvhosei_hvout_cpmuSv();					// guj^␳lAguo͒lArZl̑I
		}
	}else{
		proc_disp_save_data();									// ۑf[^̕\iXCb`Ă鎞j
		proc_buz_enable();										// uU[̂nm^neeݒiXCb`Ă鎞j
		proc_back_light();										// obNCĝnm^neesiuU[ݒ̒ŃobNCgݒ肪ύX̂Łj

		if(seep_write_pos != 0){								// rddoqnlɕۑf[^L鎞
			gpe = read_seep_gps_enable();						// rddoqnlf[^for[hrddoqnlǂݏo
			if((gpe == 1)&&(seep_gps_enable != 1)){				// rddoqnlf[^forf[^tŁAݒ肪forf[^tȂ́Ǎ̂rddoɃf[^ۑ鎞ɎxႪL̂
				clear_seep_save_data(1);						// rddoqnlf[^̑S
			}else if((gpe != 1)&&(seep_gps_enable == 1)){		// rddoqnlf[^forf[^tŁAݒ肪forf[^t鎞Ǎ̂rddoɃf[^ۑ鎞ɎxႪL̂
				clear_seep_save_data(1);						// rddoqnlf[^̑S
			}else{
				if(seep_save_mode != 0){						// ݒ̂rddoqnlf[^ۑ[hneełȂ
					ssm = read_seep_save_mode();				// rddoqnlf[^ۑ[hrddoqnlǂݏo
					if(ssm != seep_save_mode){					// rddoqnlf[^̕ۑ[hƁ@ݒ̕ۑ[hĂ鎞́Ǎ̂rddoɃf[^ۑ鎞ɎxႪL̂
						clear_seep_save_data(1);				// rddoqnlf[^̑S
					}
				}
			}
		}
		disp_clear_lcd_G();										// Clear Display
		r = rtc_read();											// RTC ǂݏo
		if(r != 0){
			rtc_error(r);
		}else{
			disp_date_time_large();								// v@̑傫ȕ\
			j = (gRTC_sec & 0x7f);								// b
			get_pgm_str(&str_clock_adjust[0]);					// vÖ̕ "R-SW Clock Adjust" 擾
			disp_lcd_G( 1,5,disp_moji);							// \
			get_pgm_str(&str_escape_this[0]);					// vÖ̕ "L-SW Escape This" 擾
			disp_lcd_G( 1,6,disp_moji);							// \
			uc = 5;
			for(i=0;i<50;i++){
				delay_ms(200);									// 100mS Delay
				r = rtc_read();									// RTC ǂݏo
				if(r != 0){
					rtc_error(r);
					break;
				}
				if (j != (gRTC_sec & 0x7f)){					// bω
					disp_date_time_large();						// v@̑傫ȕ\
					j = (gRTC_sec & 0x7f);						// b
				}
				if( (~PIND & SW_RIGHT) != 0 ){					// Right SW nm
					delay_ms(100);								// 100mS Delay
					if((~PIND & SW_RIGHT) != 0){				// Right SW nm
						r = proc_set_rtc();						// v킹
						if(r != 0){
							rtc_error(r);
							disp_clear_lcd_G();					// Clear Display
							break;
						}else{
							disp_clear_lcd_G();					// Clear Display
							disp_date_time_large();				// v@̑傫ȕ\
							get_pgm_str(&str_clock_adjust[0]);	// vÖ̕ "R-SW Clock Adjust" 擾
							disp_lcd_G( 1,5,disp_moji);			// \
							get_pgm_str(&str_escape_this[0]);	// vÖ̕ "L-SW Escape This" 擾
							disp_lcd_G( 1,6,disp_moji);			// \
							i = 0;
							j = (gRTC_sec & 0x7f);				// b
						}
					}
				}
				if( (~PIND & SW_LEFT) != 0 ){					// Left SW nm
					delay_ms(100);								// 100mS Delay
					if((~PIND & SW_LEFT) != 0){					// Left SW nm
						break;
					}
				}

				uc--;
				if(uc == 0){
					uc = 5;
					if(tim_1s_back_light != 0){
						tim_1s_back_light--;
					}
				}
			}
		}
	}

	Timer2_init();												// Timer2 Initial
	Timer1_init(0);												// Timer1 Initial
	HV_on();													// High Volt ON

	disp_clear_lcd_G();											// Clear Display
	get_pgm_str(&str_hv_monitor[0]);							// vÖ̕("HV Monitor")擾
	disp_lcd_G( 0,0,disp_moji);									// \
	if(buz_on == 1){
		get_pgm_str(&str_buz_enable[0]);						// vÖ̕("Buzzer Enable")擾
	}else{
		get_pgm_str(&str_buz_disable[0]);						// vÖ̕("Buzzer Disable")擾
	}
	disp_lcd_G( 0,1,disp_moji);									// \(Buzzer)

	if(pulse_led_on == 1){
		get_pgm_str(&str_pulse_led_enable[0]);					// vÖ̕("Pulse LED Enable")擾
	}else{
		get_pgm_str(&str_pulse_led_disable[0]);					// vÖ̕("Pulse LED Disable")擾
	}
	disp_lcd_G( 0,2,disp_moji);									// \(Pulse LED)

	if(back_light_mode == 2){									// 	nm̎
		get_pgm_str(&str_back_light_on[0]);						// vÖ̕("Back Light ON  ")擾
	}else if(back_light_mode == 1){								//@`tsn̎
		get_pgm_str(&str_back_light_auto[0]);					// vÖ̕("Back Light AUTO")擾
	}else{														//  nee̎
		get_pgm_str(&str_back_light_off[0]);					// vÖ̕("Back Light OFF ")擾
	}
	disp_lcd_G( 0,3,disp_moji);									// \(Back Light)

	if(seep_save_mode == 1){									// ݒ̂rddoqnlf[^ۑ[h
		get_pgm_str(&str_seep_save_cpm[0]);						// vÖ̕("Seep Save OFF")擾
	}else if(seep_save_mode == 2){								// ݒ̂rddoqnlf[^ۑ[h
		get_pgm_str(&str_seep_save_cph[0]);						// vÖ̕("Seep Save OFF")擾
	}else if(seep_save_mode == 3){								// ݒ̂rddoqnlf[^ۑ[h
		get_pgm_str(&str_seep_save_cpd[0]);						// vÖ̕("Seep Save OFF")擾
	}else{
		get_pgm_str(&str_seep_save_off[0]);						// vÖ̕("Seep Save OFF")擾
	}
	disp_lcd_G( 0,4,disp_moji);									// \(Seep Save)
	if((1 <= seep_save_mode)&&(seep_save_mode <= 3)){			// ݒ̂rddoqnlf[^ۑ[hAA̎
		get_pgm_str(&str_remain[0]);							// "Remain:"
		disp_lcd_G( 1,5, &disp_moji[0]);						// \
		if(seep_gps_enable == 1){								// forf[^t鎞
			wtod_5u((char *)disp_moji,(Nof_SEEP_GPS_DATA - seep_write_pos));
		}else{
			wtod_5u((char *)disp_moji,(Nof_SEEP_DATA - seep_write_pos));
		}
		for(i=1;i<4;i++){
			if(disp_moji[i] != ' '){
				break;
			}
		}
		disp_lcd_G( 8,5, &disp_moji[i]);						// \ rddoۑf[^̈̎c
		i = 6;													// for̕\sU
	}else{														// ݒ̂rddoqnlf[^ۑ[hnee
		i = 5;													// for̕\sT
	}
	get_pgm_str(&str_gps_data[0]);								// "GPS Data"
	disp_lcd_G(0,i,disp_moji);									// \
	if(seep_gps_enable == 1){									// forf[^t鎞
		get_pgm_str(&str_buz_enable[0]);						// vÖ̕("Buzzer Enable")擾
	}else{
		get_pgm_str(&str_buz_disable[0]);						// vÖ̕("Buzzer Disable")擾
	}
	disp_lcd_G( 8,i, &disp_moji[6]);							// \(GPS)

	for(i=0;i<8;i++){
		for(j=0;j<100;j++){
			ad67_set_data();									// A/D 6&7 Set A/D data to Data Buffer
			delay_ms(10);										// 10mS Delay
		}
		disp_hv_moni(12,  0);									// guj^l̕\
	}

	disp_clear_lcd_G();
	befor_count_minute = 0xffff;
	old_tim_1s_a = 0xff;
	tim_1minute = 60;
	tim_1hour = 24;
	old_hv_uSv_disp = 0xff;
	hv_uSv_disp = 0;

	meas_data_init();											// f[^̏ݒ
	disp_buz_symble();											// uU[̂nm^nee\
	set_sleep_mode(SLEEP_MODE_IDLE);							// X[vFACh[h
	count_init();												// Count Initial
	proc_1sec_passage(1);										// Pbo߂̏ij

	if(seep_gps_enable == 1){									// forf[^t鎞
		gps_init();												// 	for֌W̏
	}

	sei();														// 荞݉

	tim_1s_a = 1;												// PbPʃ^C}[
	while(tim_1s_a != 0){										// b̐؂ւ^C~O
		proc_1sec_passage(0);									// Pbo߂̏ij
	}
	cli();														// 荞݋֎~
	tim_1s_a = 60;												// PbPʃ^C}[
	for_sec_old_tim_1s_a = 60;									// blׂ̈̑Ob
	count_endless = 0;											// GhX̃JE^[
	old_count_endless = 0;										// ÕGhX̃JE^[
	count_sec_pos = 0;											// Pb̒lꏊ
	count_sec_full = 0;											// 1=Pb̒lSĖ܂
	count_minute_now = 0;										// PԖ̃JEg
	tim_10ms_led = 0;											// kdcpPOrPʃ^C}[
	tim_10ms_buz = 0;											// uU[pPOrPʃ^C}[
	sei();														// 荞݉

	for(;;){
		disp_item = 0;
		disp_any_condition = 0;
		//@XCb`
		get_sw();												//@XCb`Ԃ
		if(sw[2] != 0){											// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){							// XCb`nm̎
				hv_uSv_disp++;									// ʂ̈ڍs
				if(seep_gps_enable == 1){						// forf[^t鎞
					if(7 < hv_uSv_disp){						// W
						hv_uSv_disp = 0;
					}
				}else{
					if(6 < hv_uSv_disp){						// V
						hv_uSv_disp = 0;
					}
				}
			}

			if((sw[2] & SW_RIGHT) != 0){						// EXCb`nm̎
				buz_on ^= 1;
				disp_buz_symble();								// uU[̂nm^nee\
			}

			start_back_light();									// obNCg̎nmX^[gs
		}

		if(seep_gps_enable == 1){									// forf[^t鎞
			gps_proc();												// foȑ
		}


		if(befor_count_minute != count_minute_now){					// JE^lω
			befor_count_minute = count_minute_now;
			count_minute[cpm_data_pos] = befor_count_minute;
			// JE^\
			disp_item |= DISP_MEAS_NOW_01;							// ̒l\
		}
		proc_1sec_passage(0);										// Pbo߂̏ij
		if(tim_1s_a == 0){											// UObo߂
			count_minute_now = 0;
			tim_1s_a = 60;
			tim_1minute--;											// 
			r=rtc_read();											// RTC ǂݏo
			if(r != 0){												// ǂݏoG[̎
				rtc_error(r);
			}
			convert_date_time();									// unsigned long ̒lɕϊ
			// JE^\
			if(count_hour[cph_data_pos] == 0xffffffff){				// PԖ̃JEg܂gĂȂ
				count_hour[cph_data_pos] = 0;						// x[ɂ
			}
			count_hour[cph_data_pos] += count_minute[cpm_data_pos];	// PԖ̃JEgɑ
			save_minute_data(count_minute[cpm_data_pos]);			// PԖf[^̕ۑ
			old_pos = cpm_data_pos;
			cpm_data_pos = get_next_num_cpm();						// ̍ۑĂ鏊̂ЂƂ̔ԍ߂
			count_minute[cpm_data_pos] = 0;
			if(seep_save_mode == 1){
				seep_save_minute_data(count_minute[old_pos]);		// rddoqnlɃf[^̕ۑiPƂ̃f[^j
				if(seep_first==1){
					write_seep_save_mode();							// rddoqnlf[^ۑ[h
					write_seep_gps_enable();						// rddoqnlf[^for[hrddoqnlɏ
					seep_first = 0;
				}
			}
			disp_item |= DISP_MEAS_CPM_02;							// Ô̒l\
			disp_item |= DISP_MEAS_CPH_03;							// ̂̒l\
			if(tim_1minute == 0){									// UOo߂
				tim_1minute = 60;
				if(count_day[cpd_data_pos] == 0xffffffff){			// P̃JEg܂gĂȂ
					count_day[cpd_data_pos] = 0;					// x[ɂ
				}
				count_day[cpd_data_pos] += count_hour[cph_data_pos];	// P̃JEgɑ
				save_hour_data(count_hour[cph_data_pos]);			// PԖf[^̕ۑ
				old_pos = cph_data_pos;
				cph_data_pos = get_next_num_cph();					// ̍ۑĂ鏊̂ЂƂ̔ԍ߂
				count_hour[cph_data_pos] = 0;
				tim_1hour--;
				if(seep_save_mode == 2){
					seep_save_hour_data(count_hour[old_pos]);		// rddoqnlɃf[^̕ۑiPԂƂ̃f[^j
					if(seep_first==1){
						write_seep_save_mode();						// rddoqnlf[^ۑ[h
						write_seep_gps_enable();					// rddoqnlf[^for[hrddoqnlɏ
						seep_first = 0;
					}
				}
				disp_item |= DISP_MEAS_CPD_04;						// ̂̒l\
				if(tim_1hour == 0){									// QSԌo߂
					tim_1hour = 24;
					save_day_data(count_day[cpd_data_pos]);			// Pf[^̕ۑ
					old_pos = cpd_data_pos;
					cpd_data_pos = get_next_num_cpd();				// ̍ۑĂ鏊̂ЂƂ̔ԍ߂
					count_day[cpd_data_pos] = 0;
					if(seep_save_mode == 3){
						seep_save_day_data(count_day[old_pos]);		// rddoqnlɃf[^̕ۑiPƂ̃f[^j
						if(seep_first==1){
							write_seep_save_mode();					// rddoqnlf[^ۑ[h
							write_seep_gps_enable();				// rddoqnlf[^for[hrddoqnlɏ
							seep_first = 0;
						}
					}
					disp_item |= DISP_MEAS_CPD_07;					// Ŝ̒l\
				}
			}
			old_hv_uSv_disp = 0xff;
		}

		// LED
		if((tim_10ms_led != 0)&&(pulse_led_on == 1)){
			led_on();											// LED ON
		}else{
			led_off();											// LED OFF
		}

		// Buzzer
		if((tim_10ms_buz != 0)&&(buz_on == 1)){
			buz2_on_off(1);										// Buzzer ON
		}else{
			buz2_on_off(0);										// Buzzer OFF
		}

		if(old_hv_uSv_disp != hv_uSv_disp){						// gudAr\  ω
			old_hv_uSv_disp = hv_uSv_disp;
			if(hv_uSv_disp == 0){
				disp_meas_title();								// 荀ڂ̃^Cg\iȂj
				disp_item |= (DISP_MEAS_SEC_00 | DISP_MEAS_NOW_01 | DISP_MEAS_CPM_02 | DISP_MEAS_CPH_03 | DISP_MEAS_CPD_04 | DISP_MEAS_HV_05 | DISP_MEAS_BAT_06 | DISP_MEAS_CPD_07);
				disp_any_condition = 1;							// Iɕ\
			}else if(hv_uSv_disp == 1){
				disp_meas_title_count();						// 荀ڂ̃^Cg\iJEgj
				disp_item |= (DISP_MEAS_SEC_00 | DISP_MEAS_NOW_01 | DISP_MEAS_CPM_02 | DISP_MEAS_CPH_03 | DISP_MEAS_CPD_04 | DISP_MEAS_HV_05 | DISP_MEAS_BAT_06 | DISP_MEAS_CPD_07);
				disp_any_condition = 1;							// Iɕ\
			}else if(hv_uSv_disp == 2){
				disp_meas_title_usv_h();						// 荀ڂ̃^Cg\ir^j
				disp_item |= (DISP_MEAS_SEC_00 | DISP_MEAS_NOW_01 | DISP_MEAS_CPM_02 | DISP_MEAS_CPH_03 | DISP_MEAS_CPD_04 | DISP_MEAS_HV_05 | DISP_MEAS_BAT_06 | DISP_MEAS_CPD_07);
				disp_any_condition = 1;							// Iɕ\
			}else if(hv_uSv_disp == 3){							// cpm
				disp_item |= (DISP_MEAS_SEC_00 | DISP_MEAS_NOW_01 | DISP_MEAS_CPM_02 | DISP_MEAS_CPH_03 | DISP_MEAS_CPD_04 | DISP_MEAS_HV_05 | DISP_MEAS_BAT_06 | DISP_MEAS_CPD_07);
				disp_any_condition = 1;							// Iɕ\
			}else if(hv_uSv_disp == 4){							// cph
				disp_item |= (DISP_MEAS_SEC_00 | DISP_MEAS_NOW_01 | DISP_MEAS_CPM_02 | DISP_MEAS_CPH_03 | DISP_MEAS_CPD_04 | DISP_MEAS_HV_05 | DISP_MEAS_BAT_06 | DISP_MEAS_CPD_07);
				disp_any_condition = 1;							// Iɕ\
			}else if(hv_uSv_disp == 5){							// cpd
				disp_item |= (DISP_MEAS_SEC_00 | DISP_MEAS_NOW_01 | DISP_MEAS_CPM_02 | DISP_MEAS_CPH_03 | DISP_MEAS_CPD_04 | DISP_MEAS_HV_05 | DISP_MEAS_BAT_06 | DISP_MEAS_CPD_07);
				disp_any_condition = 1;							// Iɕ\
			}else if(hv_uSv_disp == 6){
				disp_meas_title_full();							// 荀ڂ̃^Cg\ij
				disp_item |= (DISP_MEAS_SEC_00 | DISP_MEAS_NOW_01 | DISP_MEAS_CPM_02 | DISP_MEAS_CPH_03 | DISP_MEAS_CPD_04 | DISP_MEAS_HV_05 | DISP_MEAS_BAT_06 | DISP_MEAS_CPD_07);
				disp_any_condition = 1;							// Iɕ\
			}else{
				disp_gps_title();								// forMf[^@^Cg̕\
				disp_any_condition = 1;							// Iɕ\
			}

		}

		if(for_sec_old_tim_1s_a != tim_1s_a){					// b̃JEgp̕bω
			for_sec_old_tim_1s_a = tim_1s_a;
			i = count_endless;									// GhX̃JE^[
			if(i < old_count_endless){							// GhX̃JE^[
				count_sec[count_sec_pos] = (65535 - old_count_endless) + i + 1;
			}else{
				count_sec[count_sec_pos] = i - old_count_endless;
			}
			old_count_endless = i;
			count_sec_pos++;									// Pb̒lꏊɂ
			if(60 <= count_sec_pos){							// UOȏɂȂ
				count_sec_pos = 0;								// 擪ɖ߂
				count_sec_full = 1;								// lSĖ܂
			}
		}

		if(old_tim_1s_a != tim_1s_a){							// bω
			old_tim_1s_a = tim_1s_a;
			disp_item |= DISP_MEAS_SEC_00;						// ̒l\
			disp_item |= DISP_MEAS_NOW_01;						// ̒l\
			disp_item |= DISP_MEAS_HV_05;						// ̒l\
			disp_item |= DISP_MEAS_BAT_06;						// ̒l\
			get_hv_moni();										// guj^l(Volt)̎擾(hv_moni ɓ)
			adj_hv_out();										// gupo͒l̒

			proc_back_light();									// obNCĝnm^nees

			// obe[ՌxuN
			get_bat_moni();										// obej^l(Volt)̎擾(bat_moni ɓ)
			if((battry_blink == 0) && (bat_moni <= BATTERY_LOW_DOWN)){
				battry_blink=1;
			}else if((battry_blink == 1) && (BATTERY_LOW_UP <= bat_moni)){
				battry_blink=0;
			}
			if(battry_blink == 1){
				tim_10ms_battery = 50;							// obeuNpPOrPʃ^C}[
				disp_bat_title( 0, 7, 1);						// obeږ̕\
			}else{
				tim_10ms_battery = 0;							// obeuNpPOrPʃ^C}[
			}
		}

		if(hv_uSv_disp == 0){
			disp_meas_data( &disp_item, disp_any_condition);		// 荀ڂ̕\iȂj
		}else if(hv_uSv_disp == 1){
			disp_meas_data_count( &disp_item, disp_any_condition);	// 荀ڂ̕\iJEgj
		}else if(hv_uSv_disp == 2){
			disp_meas_data_usv_h( &disp_item, disp_any_condition);	// 荀ڂ̕\ir^j
		}else if(hv_uSv_disp == 3){
			disp_cpm_graph( &disp_item, disp_any_condition);		// ̃Ot
		}else if(hv_uSv_disp == 4){
			disp_cph_graph( &disp_item, disp_any_condition);		// ̃Ot
		}else if(hv_uSv_disp == 5){
			disp_cpd_graph( &disp_item, disp_any_condition);		// ̃Ot
		}else if(hv_uSv_disp == 6){
			disp_meas_data_full( &disp_item, disp_any_condition);	// 荀ڂ̕\ij
		}else if(hv_uSv_disp == 7){
			disp_gps_data(disp_any_condition);						// forMf[^̕\
		}


		if(tim_10ms_battery_zero_now == 1){							// obeuNp̃^C}[OɂȂ
			tim_10ms_battery_zero_now = 0;							// obeuNp̃^C}[OɂȂ
			disp_bat_title( 0, 7, 0);								// obeږ
		}

		sleep_mode();												// X[vڍs
	}

}

//*****************************************
// CR & LF Set to disp_moji[]
//*****************************************
void	get_cr_lf(void)
{
	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
}
//*****************************************
// Title Set to disp_moji[]
//*****************************************
void	get_title(void)
{
	get_pgm_str(&str_title_1[0]);								// vÖ̕(TITLE1)擾
}
