//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:AVR_ATmega664_Geiger.h
//  wb_[t@C
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//  2012/03/28 Modify for All Model  Taishi(Ver 1.11) 
//  2012/03/31 Modify for All Model  Taishi(Ver 1.12) 
//  2012/06/11 Modify for All Model  Taishi(Ver 1.13 SI_21G BATTERY_LOW UM3x3) 
//*****************************************
#include	"Geiger.h"

#define			CPU_CLOCK			8				// 8:8MHz, 16:16MHz, 18:18.432MHz, 20:20MHz

//#define			DEBUG_DISP			1				// fobOp\L@{̓Rgɂ
//#define			DEBUG_TX			1				// fobOpML@{̓Rgɂ

//#define			CHECK_SW_LED_SERIAL	1				// XCb`ƂkdcƃVAʐM̃`FbN@{̓Rgɂ
//#define			CHECK_FONT			1				// tHg`FbN\iVAj^[͖j@{̓Rgɂ
//#define			CHECK_BUZZER		1				// uU[炷@{̓Rgɂ
//#define			CHECK_LCD			1				// kbc\

//#define			_SIMURATION_		1			// V~[V̎

//#define		TWI_DEBUG_ENABLE					// ꂪĂ鎞́@svh̑Mf[^PU߂Bi{̓Rgɂj

#ifdef		SI_21G
#define		BATTERY_LOW_DOWN	270					// obeȂȂ|̌xodiQVOQDVOu UM3x3j
#else		//SI_21G
#define		BATTERY_LOW_DOWN	180					// obeȂȂ|̌xodiPWOPDWOu UM3x2j
#endif		//SI_21G

#define		BATTERY_LOW_UP		BATTERY_LOW_DOWN+2	// obeȂȂ|̌x߂d

#define		N_of_DAY_DATA		64					// P̃f[^iQ̊KɌj
#define		N_of_HOUR_DATA		64					// PԖ̃f[^iQ̊KɌj
#define		N_of_MINUTE_DATA	64					// P̃f[^iPQWȉ́@Q̊KɌj


extern	unsigned long	count_day[N_of_DAY_DATA];
extern	unsigned long	count_hour[N_of_HOUR_DATA];
extern	unsigned int	count_minute[N_of_MINUTE_DATA];
extern	unsigned int	count_sec[60];				// PԂ̈ړς߂ׂ̂PbԂ̃JEg
extern	unsigned char	cpd_data_pos;
extern	unsigned char	cph_data_pos;
extern	unsigned char	cpm_data_pos;
extern	unsigned int	cpm_to_uSv_spn;				// cpm_to_uSv_spn Zl̂PO{(1000:100.0)
extern	unsigned int	cpm_to_uSv_ofs;				// cpm_to_uSv_ofs ZItZbg(JEgl炱̒l)
extern	unsigned char	tim_1minute;				// 
extern	unsigned char	tim_1hour;					// 
extern	unsigned char	pulse_led_on;				// pXkdcgp 1:gpA 0:sgp
extern	unsigned char	buz_on;						// uU[gp 1:gpA 0:sgp
extern	unsigned char	non_seep;
extern	unsigned char	tim_1s_a;					// PbPʃ^C}[
extern	unsigned char	tim_1s_back_light;			// obNCgpPbPʃ^C}[
extern	unsigned char	back_light_mode;			// obNCg̏^_[hiOFneeAPF`tsnAQFnm)
extern	unsigned char	seep_save_mode;				// rddoqnlɕۑ郂[h(0:, 1:cpm, 2:cph, 3:cpd)
extern	unsigned char	seep_gps_enable;			// rddoqnlɕۑforL^(0:, 1:L)
extern	unsigned char	count_sec_pos;				// Pb̒lꏊ
extern	unsigned char	count_sec_full;				// 1=Pb̒lSĖ܂

extern	void	get_cr_lf(void);
extern	void	get_title(void);
extern	void	wait_key_off(void);
extern	void	get_hv_moni(void);
extern	void	get_bat_moni(void);
extern	void	disp_uSv_at_count(unsigned char x, unsigned char y, unsigned long cp, unsigned char minute_data, unsigned char unit_ari);
extern	void	get_uSv_at_count(unsigned long cp, unsigned char minute_data);
extern	void	wait_sw_off(void);
extern	void	proc_back_light(void);
extern	void	start_back_light(void);
extern	void	rtc_error(unsigned char d);
