//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Const_str.c
//  Constant Strings( on PROGRAM-ROM)
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2012/03/20 New  Taishi ATmega644P
//  2012/03/28 Modify for All Model  Taishi(Ver 1.11) 
//  2012/03/31 Modify for All Model  Taishi(Ver 1.12) 
//  2012/05/07 Modify for All Model  Taishi(Ver 1.13) 
//*****************************************
#include				<avr/interrupt.h>
#include				<avr/io.h>
#include				<avr/pgmspace.h>

#include				"AVR_ATmega644_Geiger.h"
#include				"Const_str.h"

unsigned char	str_title_1[] PROGMEM            = {STR_TITLE1};				// ^Cg|P

unsigned char	str_title_2[] PROGMEM            = {"  Ver 1.13"};				// ^Cg|Q
unsigned char	str_date[] PROGMEM               = {__DATE__};					// 쐬@N
unsigned char	str_time[] PROGMEM               = {__TIME__};					// 쐬@
unsigned char	str_crlf[] PROGMEM               = {"\r\n"};					// CR + LF

#ifdef	CHECK_SW_LED_SERIAL
unsigned char	str_echo_check[] PROGMEM         = {"Echo Rec + 1"};			// "Echo Rec + 1"
unsigned char	str_echo_E[] PROGMEM             = {" Rec=\'E\' --> END"};			// " Rec=E --> END"
unsigned char	str_echo_end[] PROGMEM           = {"Echo Check End"};			// "Echo Check End"
#endif	//CHECK_SW_LED_SERIAL

#ifdef	CHECK_LCD
unsigned char	str_lcd_chk_start[] PROGMEM      = {"LCD check start"};			// "LCD check start"
#endif	//CHECK_LCD

unsigned char	str_cpm[] PROGMEM                = {"cpm"};						// "cpm"
unsigned char	str_cph[] PROGMEM                = {"cph"};						// "cph"
unsigned char	str_cpd[] PROGMEM                = {"cpd"};						// "cpd"
unsigned char	str_migi[] PROGMEM               = {"-"};						// ">"
unsigned char	str_save_data[] PROGMEM          = {"No       uSv/h"};			// "No  cph  uSv/h"
unsigned char	str_save_data_NO_RTC[] PROGMEM   = {"No          uSv/h"};		// "No  cph  uSv/h"
unsigned char	str_5minus[] PROGMEM             = {"-----"};					// "-----"
unsigned char	str_no_data[] PROGMEM            = {"Non Data !!"};				// "Non Data !!"
unsigned char	str_hv_monitor[] PROGMEM         = {"HV Monitor"};				// "HV Monitor"
unsigned char	str_buz_enable[] PROGMEM         = {"Buzzer Enable"};			// "Buzzer Enable"
unsigned char	str_buz_disable[] PROGMEM        = {"Buzzer Disable"};			// "Buzzer Disable"
unsigned char	str_data_delete[] PROGMEM        = {"Data Delete ?"};			// "Data Delete ?"

#ifdef		SW_Y_W																// Switch Color Yerror and Whute
unsigned char	str_era_y_n[] PROGMEM            = {"N:Yellow Y:White"};		// "Y:White N:Yellow"
#else		//SW_Y_W
 #ifdef		J_308
unsigned char	str_era_y_n[] PROGMEM            = {"N:Yellow Y:White"};		// "Y:White N:Yellow"
 #else		// J_308
  #ifdef	SI_22G
unsigned char	str_era_y_n[] PROGMEM            = {"N:Yellow Y:White"};		// "Y:White N:Yellow"
  #else		// SI_22G
unsigned char	str_era_y_n[] PROGMEM            = {"N:L-SW Y:R-SW"};			// "Y:R-SW N:L-SW"
  #endif	// SI_22G
 #endif		// J_308
#endif		//SW_Y_W

unsigned char	str_question[] PROGMEM           = {"?"};						// "?"
unsigned char	str_space10[] PROGMEM            = {"          "};				// "          "
unsigned char	str_volt[] PROGMEM               = {"V"};						// "V"
unsigned char	str_adj[] PROGMEM                = {"Adj"};						// "Adj"
unsigned char	str_sel[] PROGMEM                = {"Sel"};						// "Sel"
unsigned char	str_hv_moni[] PROGMEM            = {"HV-Moni"};					// "HV-Moni"
unsigned char	str_save_exit[] PROGMEM          = {"Save&Exit"};				// "Save&Exit
unsigned char	str_save_next[] PROGMEM          = {"Save&Next"};				// "Save&Next
unsigned char	str_ten8[] PROGMEM               = {"........"};				// "."

unsigned char	str_hv_out[] PROGMEM             = {"HV-Out"};					// "HV-Out"
unsigned char	str_hv_volt[] PROGMEM            = {"HV-Volt"};					// "HV-Volt"
unsigned char	str_cpm_to_uSv[] PROGMEM         = {"cpm->uSv"};				// "com->uSv"
unsigned char	str_per_h[] PROGMEM              = {"/h"};						// "/h"
unsigned char	str_uSv[] PROGMEM                = {"uSv"};						// "uSv"
unsigned char	str_span[] PROGMEM               = {"Span"};					// "Span"
unsigned char	str_offset[] PROGMEM             = {"Ofset"};					// "Ofset"

unsigned char	str_save_select1[] PROGMEM       = {"Sel cpm,cph or cpd ?"};	// "Sel cpm,cph or cpd ?"
unsigned char	str_cr_lf[] PROGMEM              = {"\r\n"};					// CR+LF
unsigned char	str_5asta[] PROGMEM              = {"*****"};					// "*****"
unsigned char	str_average[] PROGMEM            = {"Ave. "};					// "Ave. "

unsigned char	str_zero[] PROGMEM               = {"0"};						// "0"
unsigned char	str_dive[] PROGMEM               = {"/"};						// "/"
unsigned char	str_minus[] PROGMEM              = {"-"};						// "-"
unsigned char	str_asta[] PROGMEM               = {"*"};						// "*"
unsigned char	str_plus[] PROGMEM               = {"+"};						// "+"
unsigned char	str_sharp[] PROGMEM              = {"#"};						// "#"

unsigned char	str_hi[] PROGMEM                 = {"Hi"};						// "Hi"
unsigned char	str_lo[] PROGMEM                 = {"Lo"};						// "Lo"
unsigned char	str_mon_spn[] PROGMEM            = {"MON_SPN"};					// "MON_SPN"
unsigned char	str_mon_ofs[] PROGMEM            = {"MON_OFS"};					// "MON_OFS"
unsigned char	str_d_time[] PROGMEM             = {"Set Time"};				// "Set Time"

unsigned char	str_back_light_off[] PROGMEM     = {"Back Light OFF "};			// "Back Light OFF "
unsigned char	str_back_light_auto[] PROGMEM    = {"Back Light AUTO"};			// "Back Light AUTO"
unsigned char	str_back_light_on[] PROGMEM      = {"Back Light ON  "};			// "Back Light ON  "
#ifdef		SW_Y_W																// Switch Color Yerror and Whute
unsigned char	str_yl_nr[] PROGMEM              = {"Yes:Yellow No:White"};		// "Yes:WYellow No:White"
#else		//SW_Y_W
 #ifdef	J_308
unsigned char	str_yl_nr[] PROGMEM              = {"Yes:Yellow No:White"};		// "Yes:WYellow No:White"
 #else	// J_308
  #ifdef	SI_22G
unsigned char	str_yl_nr[] PROGMEM              = {"Yes:Yellow No:White"};		// "Y:White N:Yellow"
  #else		//SI_22G
unsigned char	str_yl_nr[] PROGMEM              = {"Yes:L-SW No:R-SW"};		// "Y:R-SW N:L-SW"
  #endif	// SI_22G
 #endif	// J_308
#endif		//SW_Y_W

unsigned char	str_99999999[] PROGMEM           = {"99999999"};				// "99999999"
unsigned char	str_bat[] PROGMEM                = {"Bat"};						// "Bat"
unsigned char	str_sec[] PROGMEM                = {"sec"};						// "sec"

#ifdef		SW_Y_W																// Switch Color Yerror and Whute
unsigned char	str_clock_adjust[] PROGMEM       = {"White :Clock Adjust"};		// "White Clock Adjust"
unsigned char	str_escape_this[] PROGMEM        = {"Yellow:Escape This "};		// "Yellow Escape This"
#else		//SW_Y_W
 #ifdef		J_308
unsigned char	str_clock_adjust[] PROGMEM       = {"White :Clock Adjust"};		// "White Clock Adjust"
unsigned char	str_escape_this[] PROGMEM        = {"Yellow:Escape This "};		// "Yellow Escape This"
 #else		// J_308
  #ifdef	SI_22G
unsigned char	str_clock_adjust[] PROGMEM       = {"White :Clock Adjust"};		// "White Clock Adjust"
unsigned char	str_escape_this[] PROGMEM        = {"Yellow:Escape This "};		// "Yellow Escape This"
  #else		//SI_22G
unsigned char	str_clock_adjust[] PROGMEM       = {" R-SW Clock Adjust "};		// "R-SW Clock Adjust"
unsigned char	str_escape_this[] PROGMEM        = {" L-SW Escape This "};		// "L-SW Escape This"
  #endif	// SI_22G
 #endif		// J_308
#endif		//SW_Y_W

unsigned char	str_done[] PROGMEM               = {"Done"};					// "Done"
unsigned char	str_display_end[] PROGMEM        = {"Display End ?"};			// "Display End ?"
unsigned char	str_save_data_delete[] PROGMEM   = {"Delete Save Data"};		// "Clear Save Data"
unsigned char	str_display_save_data[] PROGMEM  = {"Display Save Data"};		// "Display Save Data"
unsigned char	str_save_data_transmit[] PROGMEM = {"Transmit Save Data"};		// "Transmit Save Data"
unsigned char	str_save_data_graph[] PROGMEM    = {"Graph Save Data"};			// "Graph Save Data"
unsigned char	str_save_sel_proc[] PROGMEM      = {"Select Process"};			// "Select Process"
unsigned char	str_for_save_date[] PROGMEM      = {" for Save Data"};			// " for Save Data"
unsigned char	str_disp_vul[] PROGMEM           = {"Display Value"};			// "Display Value"
unsigned char	str_disp_grh[] PROGMEM           = {"Display Graph"};			// "Display Graph"
unsigned char	str_transmit[] PROGMEM           = {"Transmit"};				// "Transmit"
unsigned char	str_delete[] PROGMEM             = {"Delete"};					// "Delete"
unsigned char	str_exit[] PROGMEM               = {"Exit"};					// "Exit
unsigned char	str_next[] PROGMEM               = {"Next"};					// "Next
unsigned char	str_make_date[] PROGMEM          = {"Make Date:"};				// "Make Date
unsigned char	str_pulse_led_enable[] PROGMEM   = {"Pulse LED Enable"};		// "Buzzer Enable"
unsigned char	str_pulse_led_disable[] PROGMEM  = {"Pulse LED Disable"};		// "Buzzer Disable"
unsigned char	str_seep_save_off[] PROGMEM      = {"Seep Save OFF"};			// "Seep Save OFF"
unsigned char	str_seep_save_cpm[] PROGMEM      = {"Seep Save cpm"};			// "Seep Save cpm"
unsigned char	str_seep_save_cph[] PROGMEM      = {"Seep Save cph"};			// "Seep Save cph"
unsigned char	str_seep_save_cpd[] PROGMEM      = {"Seep Save cpd"};			// "Seep Save cpd"
unsigned char	str_mode_change[] PROGMEM        = {"Mode Change"};				// "Mode Change"
unsigned char	str_and[] PROGMEM                = {"and"};						// "and"
unsigned char	str_go[] PROGMEM                 = {"Go"};						// "Go"
unsigned char	str_cancel[] PROGMEM             = {"Cancel"};					// "Cancel"
unsigned char	str_transmit_seep_data[] PROGMEM = {"Transmit Seep Data"};		// "Transmit Seep Data"
unsigned char	str_display_seep_data[] PROGMEM  = {"Display Seep Data"};		// "Display Seep Data"
unsigned char	str_end[] PROGMEM                = {"END"};						// "END"
unsigned char	str_seep_delete[] PROGMEM        = {"Seep Delete"};				// "Seep Delete"
unsigned char	str_gps_data[] PROGMEM           = {"GPS Data"};				// "GPS Data"
unsigned char	str_date_moji[] PROGMEM          = {"Date"};					// "Date"
unsigned char	str_time_moji[] PROGMEM          = {"Time"};					// "Time"
unsigned char	str_count[] PROGMEM              = {"Count"};					// "Count"
unsigned char	str_utc_gmt[] PROGMEM            = {"UTC(GMT)"};				// "UTC(GMT)"
unsigned char	str_latitude[] PROGMEM           = {"Latitude(N)"};				// "Latitude(N)"
unsigned char	str_longitude[] PROGMEM          = {"Longitude(E)"};			// "Longitude(E)"
unsigned char	str_height[] PROGMEM             = {"Height"};					// "Height"
unsigned char	str_gioid[] PROGMEM              = {"Gioid"};					// "Gioid"
unsigned char	str_valid[] PROGMEM              = {"Valid"};					// "Valid"
unsigned char	str_dddmmmmmm[] PROGMEM          = {"dddmm.mmmm"};				// "dddmm.mmmm"
unsigned char	str_last[] PROGMEM               = {"last"};					// "last"
unsigned char	str_60s[] PROGMEM                = {"60s"};						// "60s"
unsigned char	str_remain[] PROGMEM             = {"Remain:"};					// "Remain"
unsigned char	str_4m[] PROGMEM                 = {"4m"};						// "4m
unsigned char	str_8m[] PROGMEM                 = {"8m"};						// "8m
unsigned char	str_16m[] PROGMEM                = {"16m"};						// "16m
unsigned char	str_32m[] PROGMEM                = {"32m"};						// "32m
unsigned char	str_60m[] PROGMEM                = {"60m"};						// "60m

