//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Gps.c
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2012/03/28 New  Taishi ATmega644P(Ver 1.11)
//  2012/03/31 Modify for All Model  Taishi(Ver 1.12) 
//  2012/03/31 Modify for All Model  Taishi(Ver 1.12) 
//*****************************************
#include		<avr/io.h>
#include		<avr/pgmspace.h>

#include		"AVR_ATmega644_Geiger.h"
#include		"Serial.h"
#include		"Utility.h"
#include		"LCD.h"
#include		"Timer.h"
#include		"Rtc.h"
#include		"Const_str.h"
#include		"Comm1.h"

#include		"Gps.h"

// #define			GPS_SUM_DEBUG		1						// GPS Data SUM Check Display ({̓RgAEg)

unsigned char	gamen_hyouji_req = 0;						// ʕ\vNA
unsigned char	pos=0;
unsigned char	stat=0;

#ifdef			GPS_SUM_DEBUG
unsigned char	gps_sum_moji[10] = {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', 0x00};
unsigned char	gps_sum_change = 0;
#endif			//GPS_SUM_DEBUG

// GPS Data
unsigned char	gps_yuukou;									// 1:f[^L
unsigned char	gps_time[11];								// EWihhmmss.ssj
unsigned char	gps_ido[11];								// ܓxi{̖k܂ɌAxx.)
unsigned char	gps_keido[11];								// oxi{̓oɌAxxx.)
unsigned char	gps_takasa[11];								// xim.m)
unsigned char	gps_gioid[11];								// WIChim.m)
unsigned char	gps_satellite[11];							// q
unsigned char	old_gps_yuukou;								// 1:ȑȎf[^L
unsigned char	old_gps_time[11];							// ȑO̐EWihhmmss.ssj
unsigned char	old_gps_ido[11];							// ȑÖܓxi{̖k܂ɌAxx.)
unsigned char	old_gps_keido[11];							// ȑǑoxi{̓oɌAxxx.)
unsigned char	old_gps_takasa[11];							// ȑO̍xim.m)
unsigned char	old_gps_gioid[11];							// ȑÕWIChim.m)
unsigned char	old_gps_satellite[11];						// q
unsigned char	gps_disp_moji[NofDispMoji+2];
unsigned char	comma_pos[20];
//*****************************************
// fordnm
//   on: 1=ON
//   \ ocT͏o͂ɂȂĂ镨Ƃ
//*****************************************
void	gps_power_on_off(unsigned char on)
{
	if(on == 1){
		PORTD &= ~(1 << PD5);				// PD5 : 'L' (ON)
	}else{
		PORTD |= (1 << PD5);				// PD5 : 'H' (OFF)
	}
}
//*****************************************
// forMf[^@^Cg̕\
//*****************************************
void	disp_gps_title(void)
{
	disp_clear_lcd_G();								// Clear Display
	get_pgm_str(&str_gps_data[0]);					// "GPS Data"
	disp_lcd_G(1,0,disp_moji);						// \

	disp_lcd_G(0, 2, (unsigned char *)("T:"));		// display LCD 3'rd Line 
	disp_lcd_G(0, 3, (unsigned char *)("N:"));		// display LCD 4'th Line k
	disp_lcd_G(0, 4, (unsigned char *)("E:"));		// display LCD 5'th Line o
	disp_lcd_G(0, 5, (unsigned char *)("H:"));		// display LCD 6'th Line x
	disp_lcd_G(0, 6, (unsigned char *)("G:"));		// display LCD 7'th Line WICh
	disp_lcd_G(0, 7, (unsigned char *)("Y:"));		// display LCD 8'th Line L
	disp_lcd_G(8, 7, (unsigned char *)("S:"));		// display LCD 8'th Line q
}
//*****************************************
// forMf[^̕\
//*****************************************
void	disp_gps_data(unsigned char disp_any_condition)
{
	char	luc[4];

	if((gamen_hyouji_req == 1)||(disp_any_condition != 0)){											// ʕ\vL肩A\̂Ƃ
		if((llstrcmp((char *)old_gps_time,(char *)gps_time) != 0)||(disp_any_condition != 0)){		// ȑO̕ƈĂ
			llstrcpy((char *)old_gps_time,(char *)gps_time);										// XV
			disp_lcd_G(2, 2, gps_time);																// display LCD 3'th Line EW \
		}

		if((llstrcmp((char *)old_gps_ido,(char *)gps_ido) != 0)||(disp_any_condition != 0)){		// ȑO̕ƈĂ
			llstrcpy((char *)old_gps_ido,(char *)gps_ido);											// XV
			disp_lcd_G(2, 3, gps_ido);																// display LCD 4'th Line ܓx \
		}

		if((llstrcmp((char *)old_gps_keido,(char *)gps_keido) != 0)||(disp_any_condition != 0)){	// ȑO̕ƈĂ
			llstrcpy((char *)old_gps_keido,(char *)gps_keido);										// XV
			disp_lcd_G(2, 4, gps_keido);															// display LCD 5'th Line ox \
		}

		if((llstrcmp((char *)old_gps_takasa,(char *)gps_takasa) != 0)||(disp_any_condition != 0)){	// ȑO̕ƈĂ
			llstrcpy((char *)old_gps_takasa,(char *)gps_takasa);									// XV
			disp_lcd_G(2, 5, gps_takasa);															// display LCD 6'th Line x \
		}

		if((llstrcmp((char *)old_gps_gioid,(char *)gps_gioid) != 0)||(disp_any_condition != 0)){	// ȑO̕ƈĂ
			llstrcpy((char *)old_gps_gioid,(char *)gps_gioid);										// XV
			disp_lcd_G(2, 6, gps_gioid);															// display LCD 7'th Line WICh \
		}

		if((old_gps_yuukou != gps_yuukou)||(disp_any_condition != 0)){								// ȑO̕ƈĂ
			old_gps_yuukou = gps_yuukou;															// XV
			wtod_2u(luc,gps_yuukou);
			disp_lcd_G(2, 7, (unsigned char *)luc);													// display LCD 8'th Line forL \
		}

		if((old_gps_satellite != gps_satellite)||(disp_any_condition != 0)){						// ȑO̕ƈĂ
			llstrcpy((char *)old_gps_satellite,(char *)gps_satellite);								// XV
			disp_lcd_G(10, 7, gps_satellite);														// display LCD 8'th Line forq \
		}

		gamen_hyouji_req = 0;
	}

#ifdef	GPS_SUM_DEBUG
	if(gps_sum_change == 1){
		gps_sum_change = 0;

		wtod_2u(luc, gps_sum_moji[8]);
		disp_lcd_G(10, 0, (unsigned char *)luc);													// display LCD 8'th Line MTnj
		disp_lcd_G(13, 0, gps_sum_moji);															// display LCD 8'th Line MT

	}
#endif	//GPS_SUM_DEBUG
}
//*****************************************
// J}T
//  \ gps_disp_moji[] ̒̃J}̈ʒuTo
//  Toꏊ [1] 珇ԂɓĂiOԖ[0]͂Oj
//*****************************************
void	get_comma_pos(void)
{
	unsigned char	i;
	unsigned char	n;

	for(i=0;i<20;i++){														// J}ʒuNA
		comma_pos[i] = 0;
	}

	n = 1; 
	for(i=0;i < NofDispMoji; i++){											// 񂪏I邩Abq܂
		if(gps_disp_moji[i] == 0){											// 񂪏I
			break;
		}else if(gps_disp_moji[i] == 0x0d){									// bq
			break;
		}else if(gps_disp_moji[i] == ','){									// J}
			if(n < (20 - 1)){												// ꏊ܂L鎞
				comma_pos[n] = i;
				n++;
			}
		}
	}
}
//*****************************************
// ̈ꕔ𔲂o
//    ds : o鏊
//        ss : o̕
//        sp : o擪̏ꏊ
//        ep : oŌ̏ꏊ
//       max : o̍ő啶
//   ̏̕I[͌ȂŎw̏ꏊ܂Ŕo
//   ȍI[ɂOOOt
//   sp  ep ȉ̕KvLBit]Ă͂Ȃj
//   sp ep ͂QTTȉłȂ΂ȂȂ
//*****************************************
void	get_str_sops_epos(unsigned char *ds, unsigned char *ss, unsigned char sp, unsigned char ep, unsigned char max)
{
	unsigned char	i;
	unsigned char	n;

	if(sp <= ep){
		for(i=sp,n=0;((i<=ep)&&(n<=max));n++,i++){
			*(ds + n) = *(ss + i);
		}
		*(ds + n) = 0;
	}
}
//*****************************************
// forf[^𕪂ĕۑ
//   ff`tH[}bǧ
//*****************************************
void	set_gps_item(void)
{
	unsigned char	uc[4];

	get_comma_pos();																		// J}T

	get_str_sops_epos(uc,             gps_disp_moji, comma_pos[6]+1,  comma_pos[ 7]-1, 3);	// ʏ
	get_str_sops_epos(gps_time,       gps_disp_moji, comma_pos[1]+1,  comma_pos[ 2]-1,10);	// EW
	get_str_sops_epos(gps_ido,        gps_disp_moji, comma_pos[2]+1,  comma_pos[ 3]-1,10);	// ܓx
	get_str_sops_epos(gps_keido,      gps_disp_moji, comma_pos[4]+1,  comma_pos[ 5]-1,10);	// ox
	get_str_sops_epos(gps_takasa,     gps_disp_moji, comma_pos[9]+1,  comma_pos[10]-1,10);	// x
	get_str_sops_epos(gps_gioid,      gps_disp_moji, comma_pos[11]+1, comma_pos[12]-1,10);	// WICh
	get_str_sops_epos(gps_satellite,  gps_disp_moji, comma_pos[7]+1, comma_pos[8]-1,10);	// q

	if(uc[0]=='1'){																			// LȎ	
		gps_yuukou = 1;																		// f[^L
	}else{
		gps_yuukou = 0;																		// f[^
	}

}

//*****************************************
// 	for֌W̏
//*****************************************
void	gps_init(void)
{
	unsigned char	i;

	PORTD |= (1 << PD5);						// PD5 : 'H' (OFF)
	DDRD |= (1 << DDD5);						// Port-D Bit5 : Output

	for(i=0;i<20;i++){							// J}ʒu
		comma_pos[i] = 0;
	}

	for(i=0;i<NofDispMoji;i++){					// \
		gps_disp_moji[i]=' ';
	}
	gps_disp_moji[i]=0;

	for(i=0;i<10;i++){
		gps_time[i] = ' ';						// EWiAXL[UhhmmssA{Ԃɂɂ́{Xj
		gps_ido[i] = ' ';						// ܓxi{̖k܂ɌAxx.)
		gps_keido[i] = ' ';						// oxi{̓oɌAxxx.)
		gps_takasa[i] = ' ';					// xi.)
		gps_gioid[i] = ' ';						// WIChi.)
		gps_satellite[i] = ' ';					// q
		old_gps_time[i] = '-';					// ȑO̐EWiAXL[UhhmmssA{Ԃɂɂ́{Xj
		old_gps_ido[i] = '-';					// ȑÖܓxi{̖k܂ɌAxx.)
		old_gps_keido[i] = '-';					// ȑǑoxi{̓oɌAxxx.)
		old_gps_takasa[i] = '-';				// ȑO̍xi.)
		old_gps_gioid[i] = '-';					// ȑÕWIChi.)
		old_gps_satellite[i] = '-';				// ȑỎq
	}
	gps_time[i] = 0;
	gps_ido[i] = 0;
	gps_keido[i] = 0;
	gps_takasa[i] = 0;
	gps_gioid[i] = 0;
	gps_satellite[i] = 0;
	old_gps_time[i] = 0;
	old_gps_ido[i] = 0;
	old_gps_keido[i] = 0;
	old_gps_takasa[i] = 0;
	old_gps_gioid[i] = 0;
	old_gps_satellite[i] = 0;

	gps_yuukou = 0;								// f[^	
	old_gps_yuukou = 0xff;						// ȑȎf[^	
	gamen_hyouji_req = 0;						// ʕ\v-->Ȃ
	pos = 0;
	stat = 0;

	uart0_gps_init();							// UART0 Initial for GPS

	gps_power_on_off(1);						// fordnm
}
//*****************************************
// f[^̃T`FbNnj̎
//  ߂l 1:T`FbNnj
//         0:T`FbNmf
// f[^	gps_disp_moji[] ɗL
//*****************************************
unsigned char	gps_sum_check(void)
{
	unsigned char	r = 0;
	unsigned char	i;
	unsigned char	sum = 0;
	char			uc[4];

	for(i=0;i<NofDispMoji;i++){					// \obt@ȓ̎
		if(gps_disp_moji[i] == '$'){			// 擪F
			sum = 0;
		}else if(gps_disp_moji[i] == 0){		// I[
			break;
		}else if(gps_disp_moji[i] == 0x2a){		// '*'Fǐ낪Tj
			wtod_02x(uc, sum);					// T𕶎ɂ
			if((uc[0] == gps_disp_moji[i+1])&&(uc[1] == gps_disp_moji[i+2])&&(gps_disp_moji[i+3] == 0)){
				r = 1;							// Tnj
			}

#ifdef	GPS_SUM_DEBUG
			gps_sum_moji[0] = gps_disp_moji[i+0];
			gps_sum_moji[1] = gps_disp_moji[i+1];
			gps_sum_moji[2] = gps_disp_moji[i+2];
			gps_sum_moji[3] = ' ';
			gps_sum_moji[4] = uc[0];
			gps_sum_moji[5] = uc[1];
			gps_sum_moji[6] = 0;
			gps_sum_moji[8] = r;
			gps_sum_change = 1;
#endif	//GPS_SUM_DEBUG

			break;
		}else{
			sum ^= gps_disp_moji[i];			// Tɂwnq
		}
	}

	return(r);
}
//*****************************************
// foȑ
//  $GPGGA ̃f[^荞
//*****************************************
void	gps_proc(void)
{
	unsigned char	uc=0;

	while(Get_rxd(&uc)==1){						// Mf[^鎞
		switch(stat){
		 case 0:								// ŏ
			if(uc == '$'){						// '$' ̎
				gps_disp_moji[pos]=uc;
				pos++;
				stat = 1;
			}
			break;
		 case 1:								// QԖ
			if(uc == 'G'){						// 'G' ̎
				gps_disp_moji[pos]=uc;
				pos++;
				stat = 2;
			}else{
				pos = 0;
				stat = 0;
			}
			break;
		 case 2:								// RԖ
			if(uc == 'P'){						// 'P' ̎
				gps_disp_moji[pos]=uc;
				pos++;
				stat = 3;
			}else{
				pos = 0;
				stat = 0;
			}
			break;
		 case 3:								// SԖ
			if(uc == 'G'){						// 'G' ̎
				gps_disp_moji[pos]=uc;
				pos++;
				stat = 4;
			}else{
				pos = 0;
				stat = 0;
			}
			break;
		 case 4:								// TԖ
			if(uc == 'G'){						// 'G' ̎
				gps_disp_moji[pos]=uc;
				pos++;
				stat = 5;
			}else{
				pos = 0;
				stat = 0;
			}
			break;
		 case 5:								// UԖ
			if(uc == 'A'){						// 'A' ̎
				gps_disp_moji[pos]=uc;
				pos++;
				stat = 6;
				tim_10ms_gps = 300;				// for($GPGAA)f[^Mfp^C}[ZbgRb
			}else{
				pos = 0;
				stat = 0;
			}
			break;
		 case 6:								// VԖ
			if(uc == 0x0d){						// CR ̎
 				gps_disp_moji[pos]=0;
				pos = 0;
				stat = 0;
				if(gps_sum_check() == 1){		// f[^̃T`FbNnj̎
					gamen_hyouji_req = 1;		// ʕ\v-->L
					set_gps_item();				// forf[^𕪂ĕۑ
				}
			}else{
				if(pos < NofDispMoji){			// \obt@ȓ̎
					gps_disp_moji[pos]=uc;
					pos++;
				}
			}
			break;
		 default:
			pos = 0;
			stat = 0;
			break;
		}
	}
	if(gps_yuukou == 1){						// f[^LȂ̂
		if(tim_10ms_gps == 0){					// K莞Ԃforf[^MoȂ
			gps_yuukou = 0;						// f[^ɂ
			for(uc=0;uc<10;uc++){
				gps_time[uc] = ' ';				// EWiAXL[UhhmmssA{Ԃɂɂ́{Xj
				gps_ido[uc] = ' ';				// ܓxi{̖k܂ɌAxx.)
				gps_keido[uc] = ' ';			// oxi{̓oɌAxxx.)
				gps_takasa[uc] = ' ';			// xi.)
				gps_gioid[uc] = ' ';			// WIChi.)
				gps_satellite[uc] = ' ';		// qi.)
				old_gps_time[uc] = '-';			// ȑO̐EWiAXL[UhhmmssA{Ԃɂɂ́{Xj
				old_gps_ido[uc] = '-';			// ȑÖܓxi{̖k܂ɌAxx.)
				old_gps_keido[uc] = '-';		// ȑǑoxi{̓oɌAxxx.)
				old_gps_takasa[uc] = '-';		// ȑO̍xi.)
				old_gps_gioid[uc] = '-';		// ȑÕWIChi.)
				old_gps_satellite[uc] = '-';	// ȑỎq
			}
			gps_time[uc] = 0;
			gps_ido[uc] = 0;
			gps_keido[uc] = 0;
			gps_takasa[uc] = 0;
			gps_gioid[uc] = 0;
			gps_satellite[uc] = 0;
			old_gps_time[uc] = 0;
			old_gps_ido[uc] = 0;
			old_gps_keido[uc] = 0;
			old_gps_takasa[uc] = 0;
			old_gps_gioid[uc] = 0;
			old_gps_satellite[uc] = 0;
		}
	}

}