//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Pulse.c
//  Use UART0
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//  2012/03/31 Modify for All Model  Taishi(Ver 1.12) 
//*****************************************
#include				<avr/interrupt.h>
#include				<avr/io.h>

#include				"AVR_ATmega644_Geiger.h"

#include				"Utility.h"
#include				"Timer.h"
#include				"Pulse.h"


unsigned int	count_minute_now;					// PԖ̃JEg
unsigned int	count_endless;						// GhX̃JE^[

// **********************************************************
// *********************** Pulse Count **********************
// **********************************************************

//***************************
// Count Initial
//***************************
void	count_init(void)
{
	unsigned char	i;

	count_endless = 0;							// GhX̃JE^[
	count_minute_now = 0;						// PԖ̃JEg
	tim_10ms_led = 0;							// kdcpPOrPʃ^C}[
	tim_10ms_buz = 0;							// uU[pPOrPʃ^C}[
	for(i=0;i<60;i++){
		count_sec[i]=0;
	}
	if((EIFR & (1 << INTF1)) != 0){				// INT1 Requset Exist
		EIFR |= (1 << INTF1);					// INT1 Request Clear
	}
	EICRA |= ( 1 << ISC11 );					// INT1 Falling Edge Interrupt
	EIMSK |= (1 << INT1);						// INT1 Interrupt Enable

}
//***************************
// INT1 Interrupt
//  Start Bit Falling Edge Sence
//***************************
ISR (INT1_vect)
{
	count_endless++;							// GhX̃JE^[
	count_minute_now++;							// P̃JEg
	if(count_minute_now == 0xffff){
		count_minute_now = 0xfffe;
	}

	tim_10ms_led = 5;
	tim_10ms_buz = 5;
}

