//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Rtc.h
//  wb_[t@C
//
// Real Time Clock DS1307
//
//  2011/09/08 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//*****************************************

#define DS1307_ID		0xD0	// I2C DS1307 Device Identifier
#define DS1307_ADDR		0x00	// I2C DS1307 Device Address

#define	RTC_ERR_TWI_START_TW_WRITE	1
#define	RTC_ERR_TWI_WRITE			2
#define	RTC_ERR_TWI_START_TW_READ	3
#define	RTC_ERR_TWI_READ			4

extern	unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
extern	unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
extern	unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
extern	unsigned char	gRTC_wday;				// qsb j̃f[^ (BCD 1--7)
extern	unsigned char	gRTC_day;				// qsb ̃f[^ (BCD 1--31)
extern	unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
extern	unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
extern	unsigned char	gRTC_control;			// qsb Rg[̃f[^
extern	unsigned long	gDate_Time;				// unsigned long ̒l(2011/12/31 23:59:59  111231235959 ɂȂ)
#define	RTC_CONTROL_RS0		0x01
#define	RTC_CONTROL_RS1		0x02
#define	RTC_CONTROL_SQWE	0x10
#define	RTC_CONTROL_OUT		0x80

extern	unsigned char	gCount_sqw;				// rpvM̃JEg
extern	unsigned char	rtc_1s_flg;				// qsbĂ鎞̂Pboߗp



extern	unsigned char	rtc_init(void);
extern	unsigned char	rtc_read(void);
extern	unsigned char	rtc_write(void);
extern	unsigned char	rtc_control_read(void);
extern	unsigned char	rtc_control_write(void);
extern	unsigned char	proc_set_rtc(void);
extern	void			disp_date_time_large(void);
extern	void			convert_date_time(void);
extern	void			convert_display_date_time(unsigned long ul);
extern	void			rtc_read_data_clear(void);

extern	void			rtc_test(void);
