//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Save_Dt.c
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2012/03/21 New  Taishi ATmega644P
//  2012/03/28 Modify for All Model  Taishi(Ver 1.11) 
//  2012/03/31 Modify for All Model  Taishi(Ver 1.12) 
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/sleep.h>
#include	<avr/eeprom.h>
#include	<avr/pgmspace.h>

#include	"AVR_ATmega644_Geiger.h"
#include	"Utility.h"
#include	"Serial.h"
#include	"LCD.h"
#include	"Display.h"
#include	"Const_str.h"
#include	"Timer.h"
#include	"EEPROM.h"
#include	"Seeprom.h"
#include	"Rtc.h"
#include	"Comm1.h"
#include	"Gps.h"

#include	"Save_Dt.h"

//
// rddoqnlۑf[^ JEgf[^SoCgAf[^SoCggƂď
// @RQoCgL̂Ł@f[^ƂĂ͂SOXUf[^邪Aĝ͂SOOOf[^Ƃ
//
unsigned char	cpm_write_pos;
unsigned short	seep_write_pos;
unsigned long	lsep_dt[16+1];					// long łPUi64 Byte)
//*****************************************
// rddo forۑf[^̍x݈̏ʒuݒ肷
//@܂ĂȂ0xffffffffɂȂĂ
//*****************************************
static
void	set_seep_write_nogps_pos(void)
{
	unsigned short	sep_dt_pos;
	unsigned short	tasu;
	unsigned char	i;

	tasu = (Nof_SEEP_DATA/2);													// l
	sep_dt_pos = Nof_SEEP_DATA - 1;
	seep_read_8(sep_dt_pos*8, (void *)(&lsep_dt[0]));

	if((lsep_dt[0] != 0xffffffff)&&(lsep_dt[1] != 0xffffffff)){					// Ō̏ꏊłȂif[^̈悪cĂȂƍlj
		seep_write_pos = sep_dt_pos+1;											// ݈ʒu͍Ō̎ɂ
	}else{
		sep_dt_pos = 0;
		seep_read_8(sep_dt_pos*8, (void *)(&lsep_dt[0]));

		if((lsep_dt[0] == 0xffffffff)&&(lsep_dt[1] == 0xffffffff)){				// ŏ̏ꏊ̎if[^ƍlj
			seep_write_pos = sep_dt_pos;										// ݈ʒu͐擪ɂ
		}else{
			sep_dt_pos += tasu;
			for(i=0;i<20;i++){
				seep_read_8((sep_dt_pos-1)*8, (void *)(&lsep_dt[0]));
				seep_read_8(sep_dt_pos*8, (void *)(&lsep_dt[2]));

				if((lsep_dt[0] != 0xffffffff)&&(lsep_dt[1] != 0xffffffff)){		// Of[^
					if((lsep_dt[2] == 0xffffffff)&&(lsep_dt[3] == 0xffffffff)){	// ̏ꏊf[^Ŗ
						seep_write_pos = sep_dt_pos;							// ݈ʒuɂ
						break;
					}else{														// ̏ꏊf[^̎iۑf[^̍Ō͂ƌƍlj
						tasu /= 2;
						if(tasu == 0){
							tasu = 1;
						}
						sep_dt_pos += tasu;
					}
				}else{															// Of[^Ŗiۑf[^Ō͂ƑOƍlj
					tasu /= 2;
					if(tasu == 0){
						tasu = 1;
					}
					sep_dt_pos -= tasu;
				}
			}
		}
	}
}
//*****************************************
// rddo forLۑf[^̍x݈̏ʒuݒ肷
//@܂ĂȂ0xffffffffɂȂĂ
//*****************************************
static
void	set_seep_write_gps_pos(void)
{
	unsigned short	sep_dt_pos;
	unsigned short	tasu;
	unsigned char	i;

	tasu = (Nof_SEEP_GPS_DATA/2);												// l
	sep_dt_pos = Nof_SEEP_GPS_DATA - 1;
	seep_read_8(sep_dt_pos*64, (void *)(&lsep_dt[0]));

	if((lsep_dt[0] != 0xffffffff)&&(lsep_dt[1] != 0xffffffff)){					// Ō̏ꏊłȂif[^̈悪cĂȂƍlj
		seep_write_pos = sep_dt_pos+1;											// ݈ʒu͍Ō̎ɂ
	}else{
		sep_dt_pos = 0;
		seep_read_8(sep_dt_pos*64, (void *)(&lsep_dt[0]));

		if((lsep_dt[0] == 0xffffffff)&&(lsep_dt[1] == 0xffffffff)){				// ŏ̏ꏊ̎if[^ƍlj
			seep_write_pos = sep_dt_pos;										// ݈ʒu͐擪ɂ
		}else{
			sep_dt_pos += tasu;
			for(i=0;i<20;i++){
				seep_read_8((sep_dt_pos-1)*64, (void *)(&lsep_dt[0]));
				seep_read_8(sep_dt_pos*64, (void *)(&lsep_dt[2]));

				if((lsep_dt[0] != 0xffffffff)&&(lsep_dt[1] != 0xffffffff)){		// Of[^
					if((lsep_dt[2] == 0xffffffff)&&(lsep_dt[3] == 0xffffffff)){	// ̏ꏊf[^Ŗ
						seep_write_pos = sep_dt_pos;							// ݈ʒuɂ
						break;
					}else{														// ̏ꏊf[^̎iۑf[^̍Ō͂ƌƍlj
						tasu /= 2;
						if(tasu == 0){
							tasu = 1;
						}
						sep_dt_pos += tasu;
					}
				}else{															// Of[^Ŗiۑf[^Ō͂ƑOƍlj
					tasu /= 2;
					if(tasu == 0){
						tasu = 1;
					}
					sep_dt_pos -= tasu;
				}
			}
		}
	}
}
//*****************************************
// rddoۑf[^̍x݈̏ʒuݒ肷
//*****************************************
void	set_seep_write_pos(void)
{
	unsigned char	gpe;

	gpe = read_seep_gps_enable();					// rddoqnlf[^for[hrddoqnlǂݏo
	if(gpe == 1){
		set_seep_write_gps_pos();					// rddo forLۑf[^̍x݈̏ʒuݒ肷
	}else{
		set_seep_write_nogps_pos();					// rddo forۑf[^̍x݈̏ʒuݒ肷
	}
}
//*****************************************
// forf[^obt@ɃZbg
//   forf[^̈ܓxAoxACAWIChx
//   lsep_dt[2] lsep_dt[15]܂ŗ̈(56Byte)ɃAXL[ŃZbg
//   0--> 9 EW(hhmmss.sss)
//  10      ','
//  11-->21 ܓx(DDDmm.mmmm)
//  22      ','
//  23-->33 ox(DDDmm.mmmm)
//  34      ','
//  35-->42 x
//  43      ','
//  44-->51 WICh
//  52      ','
//  53      ʗLi1:L@0:j
//  54      ','
//  55      0x00
//*****************************************
static
void	set_gps_data_to_lsep_dt(void)
{
	char			*ucp;
	unsigned char	i;
	short			len;

	ucp = (char *)(&lsep_dt[2]);					// 擪
	for(i=0;i<56;i++){								// ŏɃXy[XŃNA
		*(ucp+i) = ' ';
	}
	*(ucp+55) = 0x00;


	len = llstrlen((char *)gps_time);				// EW̕
	if(10 < len){
		len = 10;
	}
	llstrncpy(ucp + 0, (char *)gps_time, len);
	*(ucp+10) = ',';

	len = llstrlen((char *)gps_ido);				// ܓx̕
	if(10 < len){
		len = 10;
	}
	llstrncpy(ucp + 11, (char *)gps_ido, len);
	*(ucp+22) = ',';

	len = llstrlen((char *)gps_keido);				// ox̕
	if(10 < len){
		len = 10;
	}
	llstrncpy(ucp + 23, (char *)gps_keido, len);
	*(ucp+34) = ',';

	len = llstrlen((char *)gps_takasa);				// x̕
	if(7 < len){
		len = 7;
	}
	llstrncpy(ucp + 35, (char *)gps_takasa, len);
	*(ucp+43) = ',';

	len = llstrlen((char *)gps_gioid);				// WICh̕
	if(7 < len){
		len = 7;
	}
	llstrncpy(ucp + 44, (char *)gps_gioid, len);
	*(ucp+52) = ',';

	if(gps_yuukou == 1){							// ʃf[^L̎
		*(ucp+53) = '1';
	}else{
		*(ucp+53) = '0';
	}
	*(ucp+54) = ',';
	*(ucp+55) = 0x00;

}
//*****************************************
// forf[^oď̏ꏊɃZbg
//   forf[^̈ܓxAoxACAWIChx
//   lsep_dt[2] lsep_dt[15]܂ŗ̈(56Byte)@oĂ̒lɃZbg
//   0--> 9 EW(hhmmss.sss)
//  10      ','
//  11-->21 ܓx(DDDmm.mmmm)
//  22      ','
//  23-->33 ox(DDDmm.mmmm)
//  34      ','
//  35-->42 x
//  43      ','
//  44-->51 WICh
//  52      ','
//  53      ʗLi1:L@0:j
//  54      ','
//  55      0x00
//  @  cp: forf[^̕
//  ߂l  0:forf[^A 1:forf[^L
//  ꏊ
//     : gps_time
//    ܓx : gps_ido
//    ox : gps_keido
//    x : gps_takasa
//    WICh : gps_gioid
//*****************************************
static
unsigned char	get_gps_data_to_lsep_dt(char *cp)
{
	unsigned char	gy;

	llstrncpy((char *)gps_time, cp + 0, 10);		// EW
	gps_time[10] = 0;

	llstrncpy((char *)gps_ido, cp + 11, 10);		// ܓx
	gps_ido[10] = 0;

	llstrncpy((char *)gps_keido, cp + 23, 10);		// ox
	gps_keido[10] = 0;

	llstrncpy((char *)gps_takasa, cp + 35, 7);		// x
	gps_takasa[7] = 0;

	llstrncpy((char *)gps_gioid, cp + 44, 7);		// WICh
	gps_gioid[7] = 0;

	if( *(cp+53) == '1'){							// ʃf[^L̎
		gy = 1;
	}else{
		gy = 0;
	}

	return(gy);
}

//*****************************************
// rddoqnlɃf[^̕ۑiPƂ̃f[^j
//*****************************************
void	seep_save_day_data(unsigned long ul)
{
	lsep_dt[0] = ul;													// JEgf[^
	lsep_dt[1] = gDate_Time;											// f[^

	if(seep_gps_enable == 1){											// forf[^L̎
		if(seep_write_pos < Nof_SEEP_GPS_DATA){							// ẍ̎
			set_gps_data_to_lsep_dt();									// forf[^obt@ɃZbg
			seep_write_64(seep_write_pos * 64, (void *)(&lsep_dt[0]));	// Seeprom WoCgf[^̏
			seep_write_pos++;
		}
	}else{
		if(seep_write_pos < Nof_SEEP_DATA){								// ẍ̎
			seep_write_8(seep_write_pos * 8, (void *)(&lsep_dt[0]));	// Seeprom WoCgf[^̏
			seep_write_pos++;
		}
	}
}
//*****************************************
// rddoqnlɃf[^̕ۑiPԂƂ̃f[^j
//*****************************************
void	seep_save_hour_data(unsigned long ul)
{
	lsep_dt[0] = ul;													// JEgf[^
	lsep_dt[1] = gDate_Time;											// f[^
	if(seep_gps_enable == 1){											// forf[^L̎
		if(seep_write_pos < Nof_SEEP_GPS_DATA){							// ẍ̎
			set_gps_data_to_lsep_dt();									// forf[^obt@ɃZbg
			seep_write_64(seep_write_pos * 64, (void *)(&lsep_dt[0]));	// Seeprom WoCgf[^̏
			seep_write_pos++;
		}
	}else{
		if(seep_write_pos < Nof_SEEP_DATA){								// ẍ̎
			seep_write_8(seep_write_pos * 8, (void *)(&lsep_dt[0]));	// Seeprom WoCgf[^̏
			seep_write_pos++;
		}
	}
}
//*****************************************
// rddoqnlɃf[^̕ۑiPƂ̃f[^j
//*****************************************
void	seep_save_minute_data(unsigned int ui)
{
	lsep_dt[0] = (long)ui;												// JEgf[^
	lsep_dt[1] = gDate_Time;											// f[^
	if(seep_gps_enable == 1){											// forf[^L̎
		if(seep_write_pos < Nof_SEEP_GPS_DATA){							// ẍ̎
			set_gps_data_to_lsep_dt();									// forf[^obt@ɃZbg
			seep_write_64(seep_write_pos * 64, (void *)(&lsep_dt[0]));	// Seeprom WoCgf[^̏
			seep_write_pos++;
		}
	}else{
		if(seep_write_pos < Nof_SEEP_DATA){								// ẍ̎
			seep_write_8(seep_write_pos * 8, (void *)(&lsep_dt[0]));	// Seeprom WoCgf[^̏
			seep_write_pos++;
		}
	}
}
//*****************************************
// rddoqnlf[^̑S
//*****************************************
void	delete_seep_all_data(void)
{
	unsigned short	us;

	for(us=0;us<16;us++){
		lsep_dt[us] = 0xffffffff;							// f[^Ŗ߂
	}

	wtod_5u((char *)disp_moji,512);
	disp_lcd_G(14, 5, &disp_moji[2]);						// display Dot Matrix LCD
	get_pgm_str(&str_dive[0]);								// vÖ̕("V")擾
	disp_lcd_G(13,5,disp_moji);								// \
	for(us=0;us<512;us++){
		seep_write_64(us * 64, (void *)(&lsep_dt[0]));
		wtod_5u((char *)disp_moji,us+1);
		disp_lcd_G(10, 5, &disp_moji[2]);					// display Dot Matrix LCD
	}
	seep_write_pos = 0;										// ݈ʒu͐擪ɂ
}
//*****************************************
// rddoqnlf[^ۑ[hrddoqnlɏ
//*****************************************
void	write_seep_save_mode(void)
{
	seep_write_1(SEEP_SAVE_MODE_ADR, &seep_save_mode);	// Seeprom PoCgf[^̏
}
//*****************************************
// rddoqnlf[^ۑ[hrddoqnlǂݏo
//*****************************************
unsigned char	read_seep_save_mode(void)
{
	unsigned char	uc;

	seep_read_1(SEEP_SAVE_MODE_ADR, &uc);				// Seeprom PoCgf[^̓ǂݏo
	return(uc);
}
//*****************************************
// rddoqnlf[^for[hrddoqnlɏ
//*****************************************
void	write_seep_gps_enable(void)
{
	seep_write_1(SEEP_GPS_ENABLE_ADR, &seep_gps_enable);	// Seeprom PoCgf[^̏
}
//*****************************************
// rddoqnlf[^for[hrddoqnlǂݏo
//*****************************************
unsigned char	read_seep_gps_enable(void)
{
	unsigned char	uc;

	seep_read_1(SEEP_GPS_ENABLE_ADR, &uc);				// Seeprom PoCgf[^̓ǂݏo
	return(uc);
}
//*****************************************
// f[^̕ۑiPƂ̃f[^j
// @荞݉̏ԂŌĂ΂Ƃ
//*****************************************
void	save_day_data(unsigned long ul)
{
	unsigned int	uc;

	eeprom_busy_wait();
	uc = eeprom_read_byte(&eep_cpd_write_pos);			// ۑʒu
	if(N_of_HOUR_DATA <= uc){
		uc = 0;
	}

	cli();												// 荞ݕs
	eeprom_busy_wait();
	eeprom_write_dword(eep_day_data + uc, ul);			// f[^̕ۑ
	sei();												// 荞݉

	cli();												// 荞ݕs
	eeprom_busy_wait();
	eeprom_write_dword(eep_day_time_data + uc, gDate_Time);	// Pf[^̕ۑ
	sei();												// 荞݉

	uc++;
	if(N_of_HOUR_DATA <= uc){
		uc = 0;
	}

	cli();												// 荞ݕs
	eeprom_busy_wait();
	eeprom_write_byte(&eep_cpd_write_pos, uc);			// ̕ۑʒu
	sei();												// 荞݉
}
//*****************************************
// f[^̕ۑiPԂƂ̃f[^j
// @荞݉̏ԂŌĂ΂Ƃ
//*****************************************
void	save_hour_data(unsigned long ul)
{
	unsigned int	uc;

	eeprom_busy_wait();
	uc = eeprom_read_byte(&eep_cph_write_pos);			// ۑʒu
	if(N_of_HOUR_DATA <= uc){
		uc = 0;
	}

	cli();												// 荞ݕs
	eeprom_busy_wait();
	eeprom_write_dword(eep_hour_data + uc, ul);			// f[^̕ۑ
	sei();												// 荞݉

	cli();												// 荞ݕs
	eeprom_busy_wait();
	eeprom_write_dword(eep_hour_time_data + uc, gDate_Time);	// PԖf[^̕ۑ
	sei();												// 荞݉

	uc++;
	if(N_of_HOUR_DATA <= uc){
		uc = 0;
	}

	cli();												// 荞ݕs
	eeprom_busy_wait();
	eeprom_write_byte(&eep_cph_write_pos, uc);			// ̕ۑʒu
	sei();												// 荞݉
}
//*****************************************
// ꕪƃf[^̍x݈̏ʒuݒ肷
//@ڂ0xffffƂłȂf[^Ă鏊Ł@0xffff̏x
//  USȂ̂ŏԂɒT
//  vONɂPĂ
//*****************************************
void	set_cpm_write_pos(void)
{
	unsigned char	i;
	unsigned int	ui0;
	unsigned int	ui1;

	eeprom_busy_wait();
	ui1 = eeprom_read_word(eep_minute_data + 1);					// [1] 
	eeprom_busy_wait();
	ui0 = eeprom_read_word(eep_minute_data + 0);					// [0] 
	if((ui1 == 0xffff)&&(ui0 == 0xffff)){							// 0xffff ̎́if[^Ax[0]̎j
		cpm_write_pos = 0;											// xꏊ[0]
	}else{															// ۑf[^P͗L鎞
		eeprom_busy_wait();
		ui0 = eeprom_read_word(eep_minute_data + N_of_MINUTE_DATA - 1);
		for(i=N_of_MINUTE_DATA; 1 < i; i--){
			ui1 = ui0;												// xꏊɂ鏊
			eeprom_busy_wait();
			ui0 = eeprom_read_word(eep_minute_data + i - 2);		// Iꏊɂ鏊̓ǂݏo
			if((ui1 == 0xffff)&&(ui0 != 0xffff)){					// ڂƔF
				break;
			}
		}
		cpm_write_pos = (i - 1);
	}

}
//*****************************************
// Pf[^̕ۑ
// @荞݉̏ԂŌĂ΂Ƃ
//   ۑʒu͂ddoqnlɏANɕۑf[^瓱ꏊ̒lg
//   ۑf[^̈̃f[^Oɂā@Vf[^̖ڈɂ
//*****************************************
void	save_minute_data(unsigned int ui)
{
	unsigned char	uc;
	unsigned char	uc1;

	uc = cpm_write_pos;									// 񏑂

	// 񏑂̎̏ɂȌׂꏊ̌vZ
	uc1 = uc;
	uc1++;
	if(N_of_MINUTE_DATA <= uc1){
		uc1 = 0;
	}

	cli();												// 荞ݕs
	eeprom_busy_wait();
	eeprom_write_word(eep_minute_data + uc1, 0xffff);	// ڈf[^̕ۑiڈf[^͖{̃f[^葁ȂƁ@rœd؂ꂽɖڈ󂪏ȂȂĂ܂j
	sei();												// 荞݉

	cli();												// 荞ݕs
	eeprom_busy_wait();
	eeprom_write_word(eep_minute_data + uc, ui);		// Pf[^̕ۑ
	sei();												// 荞݉

	cli();												// 荞ݕs
	eeprom_busy_wait();
	eeprom_write_dword(eep_minute_time_data + uc, gDate_Time);	// Pf[^̕ۑ
	sei();												// 荞݉

	cpm_write_pos = uc1;								// 񏑂
}
//*****************************************
// Pf[^̑S
// @荞݉̏ԂŌĂ΂Ƃ
//*****************************************
void	delete_day_data(void)
{
	unsigned char	uc;

	cli();													// Öׁ@荞ݕs
	uc = 0xff;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_cpd_write_pos, uc);				// ̕ۑʒu

	for(uc = 0; uc < N_of_EEP_DAY_DATA; uc++){
		eeprom_busy_wait();
		eeprom_write_dword(eep_day_data + uc, 0xffffffff);	// Pf[^̕ۑ
		eeprom_busy_wait();
		eeprom_write_dword(eep_day_time_data + uc, 0xffffffff);	// Pf[^̓
	}
}
//*****************************************
// PԖf[^̑S
// @荞݉̏ԂŌĂ΂Ƃ
//*****************************************
void	delete_hour_data(void)
{
	unsigned char	uc;

	cli();													// Öׁ@荞ݕs
	uc = 0xff;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_cph_write_pos, uc);				// ̕ۑʒu

	for(uc = 0; uc < N_of_EEP_HOUR_DATA; uc++){
		eeprom_busy_wait();
		eeprom_write_dword(eep_hour_data + uc, 0xffffffff);	// PԖf[^̕ۑ
		eeprom_busy_wait();
		eeprom_write_dword(eep_hour_time_data + uc, 0xffffffff);	// PԖf[^̓
	}
}
//*****************************************
// Pf[^̑S
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	delete_minute_data(void)
{
	unsigned char	uc;

	cli();													// Öׁ@荞ݕs
	cpm_write_pos = 0;
	for(uc = 0; uc < N_of_EEP_MINUTE_DATA; uc++){
		eeprom_busy_wait();
		eeprom_write_word(eep_minute_data + uc, 0xffff);	// PԖf[^̕ۑ
		eeprom_busy_wait();
		eeprom_write_dword(eep_minute_time_data + uc, 0xffffffff);	// PԖf[^̓
	}
}

//*****************************************
// ۑf[^iPԖ͂PԂƁj̕\
// cph: 0=cpm Data, 1=cph Data, 2=cpd Data
//*****************************************
void	disp_cph_save_data(unsigned char cph)
{
	unsigned char	j;
	unsigned char	i;
	unsigned char	uc;
	unsigned long	ul;
	unsigned int	ui;
	unsigned char	saidai;
	unsigned char	end = 0;

	disp_clear_lcd_G();								// Clear Display
	get_pgm_str(&str_save_data[0]);					// PԖf[^̃^Cg擾
	disp_lcd_G(1,0,disp_moji);						// \
	if(cph == 0){									// PԂƃf[^(cpm)̎
		get_pgm_str(&str_cpm[0]);					// ̎擾
		disp_lcd_G(5,0,disp_moji);					// \
	}else if(cph == 1){								// PԂƃf[^(cph)̎
		get_pgm_str(&str_cph[0]);					// ̎擾
		disp_lcd_G(5,0,disp_moji);					// \
	}else{											// Pƃf[^(cpd)̎
		get_pgm_str(&str_cpd[0]);					// ̎擾
		disp_lcd_G(5,0,disp_moji);					// \
	}

	wait_sw_off();									// Q̃XCb`Q@܂ŉiv[v

	eeprom_busy_wait();
	if(cph == 0){									// PԂƃf[^(cpm)̎
		uc = cpm_write_pos;							// ̕ۑʒu
		saidai = N_of_EEP_MINUTE_DATA;
	}else if(cph == 1){								// PԖf[^̎
		uc = eeprom_read_byte(&eep_cph_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_HOUR_DATA;
	}else{											// Pf[^̎
		uc = eeprom_read_byte(&eep_cpd_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_DAY_DATA;
	}
	if(uc == 0xff){									// ۑ
		get_pgm_str(&str_no_data[0]);				// vÖ̕("No Data !!")擾
		disp_lcd_G( 3,1,disp_moji);					// \
	
		delay_ms(4000);								// 4000mS Delay

	}else{												// ۑL鎞
		i = 1;
		for(;;){
			if(i == 0){
				disp_clear_lcd_G();						// Clear Display
				get_pgm_str(&str_display_end[0]);		// vÖ̕("Display End")擾
				disp_lcd_G( 0,1,disp_moji);				// \
				get_pgm_str(&str_era_y_n[0]);			// vÖ̕("Y:R-SW N:L-SW")擾
				disp_lcd_G( 0,2,disp_moji);				// \
				i++;
			}else{
				for(j= 0; j<3; j++){
					uc--;
					if(saidai <= uc){
						uc = (saidai - 1);
					}

					wtod_02u((char *)(&disp_moji[1]), i);		// ԍ
					if(disp_moji[1]=='0'){
						disp_moji[0]=' ';
						disp_moji[1]='-';
					}else{
						disp_moji[0]='-';
					}
					disp_lcd_G(0, 1+j*2, &disp_moji[0]);								// display Dot Matrix LCD Down Side

					eeprom_busy_wait();
					if(cph == 0){														// PԂƃf[^(cpm)̎
						ul = eeprom_read_dword(eep_minute_time_data + uc);				// PԖf[^̎ǂݏo
					}else if(cph == 1){													// PԖf[^(cph)̎
						ul = eeprom_read_dword(eep_hour_time_data + uc);				// PԖf[^̎ǂݏo
					}else{																// Pf[^(cpd)̎
						ul = eeprom_read_dword(eep_day_time_data + uc);					// Pf[^̎ǂݏo
					}
					convert_display_date_time(ul);										// unsigned long ̒l\pɕϊ
					disp_lcd_G(4,1+j*2,disp_moji);										// \

					eeprom_busy_wait();
					if(cph == 0){														// PԂƃf[^(cpm)̎
						ul = (unsigned long)eeprom_read_word(eep_minute_data + uc);		// PԖf[^̓ǂݏo
						if(ul == 0xffff){
							ul = 0xffffffff;
						}
					}else if(cph == 1){													// PԖf[^(cph)̎
						ul = eeprom_read_dword(eep_hour_data + uc);						// PԖf[^̓ǂݏo
					}else{																// Pf[^(cpd)̎
						ul = eeprom_read_dword(eep_day_data + uc);						// Pf[^̓ǂݏo
					}
					if(ul == 0xffffffff){
						get_pgm_str(&str_5minus[0]);									// "-----"
						disp_lcd_G(2,2+j*2,&disp_moji[0]);								// \
						disp_lcd_G(7,2+j*2,&disp_moji[3]);								// \
						disp_lcd_G(11,2+j*2,&disp_moji[1]);								// \
					}else{
						ui = (unsigned short)(ul/10000);
						wtod_7u((char *)disp_moji, ul);									// PԖ͂PԂƂ̃JEg
						disp_lcd_G(2, 2+j*2, &disp_moji[0]);							// display Dot Matrix LCD Down Side
						if(cph == 0){													// PԂƃf[^(cpm)̎
							disp_uSv_at_count(11, 2+j*2, ul, 1, 0);						// rZ\iPԂ̃JEgɂj
						}else if(cph == 2){
							disp_uSv_at_count(11, 2+j*2, ul/(unsigned long)24, 0, 0);	// rZ\iPԂ̃JEgɂj
						}else{
							disp_uSv_at_count(11, 2+j*2, ul, 0, 0);						// rZ\iPԂ̃JEgɂj
						}

					}

					i++;
					if(saidai < i){
						// c̑O\NA
						j++;
						for(;j<3;j++){
							get_pgm_str(&str_space10[0]);		// vÖ̕("      ")擾
							disp_lcd_G( 0,1+j*2,disp_moji);		// \
							disp_lcd_G(10,1+j*2,disp_moji);		// \
							disp_lcd_G( 0,2+j*2,disp_moji);		// \
							disp_lcd_G(10,2+j*2,disp_moji);		// \
						}
						i = 0;
						break;
					}
				}
			}
			wait_sw_off();									// Q̃XCb`Q@܂ŉiv[v

// XCb`ꂽi܂ŉiv[vj
			while(1){
				if((PIND & SW_LEFT) == 0){
					delay_ms(50);							// 50mS Delay
					if((PIND & SW_LEFT) == 0){
						break;								// {ɉꂽƂ
					}
				}else if( ((PIND & SW_RIGHT) == 0)&&(i == 1)){
					delay_ms(100);							// 100mS Delay
					if((PIND & SW_RIGHT) == 0){
						end = 1;
						break;
					}
				}
			}

			if(end == 1){
				break;
			}
			if(i == 1){
				disp_clear_lcd_G();							// Clear Display
				get_pgm_str(&str_save_data[0]);				// PԖf[^̃^Cg擾
				disp_lcd_G(1,0,disp_moji);					// \
				if(cph == 0){								// PԂƃf[^(cpm)̎
					get_pgm_str(&str_cpm[0]);				// ̎擾
					disp_lcd_G(5,0,disp_moji);				// \
				}else if(cph == 1){							// PԂƃf[^(cph)̎
					get_pgm_str(&str_cph[0]);				// ̎擾
					disp_lcd_G(5,0,disp_moji);				// \
				}else{										// Pƃf[^(cpd)̎
					get_pgm_str(&str_cpd[0]);				// ̎擾
					disp_lcd_G(5,0,disp_moji);				// \
				}
			}

		}
	}
}
//*****************************************
// ۑf[^iPԖ͂PԂƁj̍폜
// cph: 0=cpm Data, 1=cph Data, 2=cpd Data
//*****************************************
void	clear_cph_save_data(unsigned char cph)
{
	disp_clear_lcd_G();								// Clear Display
	if(cph == 0){									// PԂƃf[^(cpm)̎
		get_pgm_str(&str_cpm[0]);					// ̎擾
		disp_lcd_G(0,0,disp_moji);					// \
	}else if(cph == 1){								// PԂƃf[^(cph)̎
		get_pgm_str(&str_cph[0]);					// ̎擾
		disp_lcd_G(0,0,disp_moji);					// \
	}else{											// Pƃf[^(cpd)̎
		get_pgm_str(&str_cpd[0]);					// ̎擾
		disp_lcd_G(0,0,disp_moji);					// \
	}
	get_pgm_str(&str_data_delete[0]);				// vÖ̕("Data Delete ?")擾
	disp_lcd_G( 0,1,disp_moji);						// \

	wait_sw_off();									// Q̃XCb`Q@܂ŉiv[v

	get_pgm_str(&str_era_y_n[0]);					// vÖ̕("Y:R-SW N:L-SW")擾
	disp_lcd_G( 3,5,disp_moji);						// \

// XCb`ꂽi܂ŉiv[vj
	while(1){
		if((PIND & SW_LEFT) == 0){
			delay_ms(50);							// 50mS Delay
			if((PIND & SW_LEFT) == 0){
				break;								// {ɉꂽƂ
			}
		}else if( (PIND & SW_RIGHT) == 0 ){
			delay_ms(100);							// 100mS Delay
			if((PIND & SW_RIGHT) == 0){
				if(cph == 0){						// PԂƃf[^(cpm)̎
					delete_minute_data();			// PԖf[^̑S
				}else if(cph == 1){					// PԖf[^̎
					delete_hour_data();				// PԖf[^̑S
				}else{								// Pf[^̎
					delete_day_data();				// Pf[^̑S
				}
				get_pgm_str(&str_space10[0]);		// vÖ̕("      ")擾
				disp_lcd_G( 0,5,disp_moji);			// \
				disp_lcd_G(10,5,disp_moji);			// \
				get_pgm_str(&str_done[0]);			// vÖ̕("Done")擾
				disp_lcd_G( 8,5,disp_moji);			// \
				delay_ms(2000);						// 2000mS Delay
				break;
			}
		}
	}
}
//*****************************************
// ۑf[^iA  j̑I
//   OFl\
//  @@ PFOt\
//  @@ QFM
//  @@ RF
//*****************************************
void	select_save_data(unsigned char proc_sel)
{
	unsigned char	sel=0;
	unsigned char	kesu=1;

	disp_clear_lcd_G();								// Clear Display
	if(proc_sel == 3){
		get_pgm_str(&str_save_data_delete[0]);		// vÖ̕("Delete Save Data")擾
	}else if(proc_sel == 2){
		get_pgm_str(&str_save_data_transmit[0]);	// vÖ̕("Transmit Save Data")擾
	}else if(proc_sel == 1){
		get_pgm_str(&str_save_data_graph[0]);		// vÖ̕("Graph Save Data")擾
	}else{
		get_pgm_str(&str_display_save_data[0]);		// vÖ̕("Display Save Data")擾
	}
	disp_lcd_G( 0,0,disp_moji);						// \
	get_pgm_str(&str_save_select1[0]);				// vÖ̕("Sel cpm or cph ?")擾
	disp_lcd_G( 0,1,disp_moji);						// \

	get_pgm_str(&str_cpm[0]);						// "cpm"
	disp_lcd_G( 0,2,disp_moji);						// \
	get_pgm_str(&str_cph[0]);						// "cph"
	disp_lcd_G( 0,3,disp_moji);						// \
	get_pgm_str(&str_cpd[0]);						// "cpd"
	disp_lcd_G( 0,4,disp_moji);						// \

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){												// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;

			kesu ^= 1;														// I̓_
			if(kesu == 0){													// _ł̓_̎
				get_pgm_str(&str_cpm[0]);									// "cpm"
				disp_lcd_G( 0,2,disp_moji);									// \
				get_pgm_str(&str_cph[0]);									// "cph"
				disp_lcd_G( 0,3,disp_moji);									// \
				get_pgm_str(&str_cpd[0]);									// "cpd"
				disp_lcd_G( 0,4,disp_moji);									// \
			}else{															// _ł̖ł̎
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(sel == 0){
					disp_lcd_G(0,2, &disp_moji[0]);							// Xy[X\
				}else if(sel == 1){
					disp_lcd_G(0,3, &disp_moji[0]);							// Xy[X\
				}else{
					disp_lcd_G(0,4, &disp_moji[0]);							// Xy[X\
				}
			}
		}
		get_sw();															//@XCb`Ԃ
		if(sw[2] != 0){														// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){										// XCb`
				sel++;
				if(2 < sel){
					sel = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){								// EXCb`
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(sel == 0){
					disp_lcd_G(0,3, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,4, &disp_moji[0]);							// Xy[X\
					get_pgm_str(&str_cpm[0]);								// "cpm"
					disp_lcd_G( 0,2,disp_moji);								// \
				}else if(sel == 1){
					disp_lcd_G(0,2, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,4, &disp_moji[0]);							// Xy[X\
					get_pgm_str(&str_cph[0]);								// "cph"
					disp_lcd_G( 0,3,disp_moji);								// \
				}else{
					disp_lcd_G(0,2, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,3, &disp_moji[0]);							// Xy[X\
					get_pgm_str(&str_cpd[0]);								// "cpd"
					disp_lcd_G(0,4,disp_moji);								// \
				}
				break;
			}
		}
	}
	wait_key_off();											// Q̃XCb`Q@܂ŉiv[v

	cli();

	if(proc_sel == 3){
		if(sel == 0){										// cpm
			clear_cph_save_data(0);							// ۑf[^iPԂƁj̍폜
		}else if(sel == 1){									// cph
			clear_cph_save_data(1);							// ۑf[^iPԂƁj̍폜
		}else{												// cpd
			clear_cph_save_data(2);							// ۑf[^iPƁj̍폜
		}
	}else if(proc_sel == 2){
		if(sel == 0){										// cpm
			transmit_cph_save_data(0);						// ۑf[^iPԂƁj̑M
		}else if(sel == 1){									// cph
			transmit_cph_save_data(1);						// ۑf[^iPԂƁj̑M
		}else{												// cpd
			transmit_cph_save_data(2);						// ۑf[^iPƁj̑M
		}
	}else if(proc_sel == 1){
		if(sel == 0){										// cpm
			graph_cph_save_data(0);							// ۑf[^iPԂƁj̃Ot\
		}else if(sel == 1){									// cph
			graph_cph_save_data(1);							// ۑf[^iPԂƁj̃Ot\
		}else{												// cpd
			graph_cph_save_data(2);							// ۑf[^iPƁj̃Ot\
		}
	}else{
		if(sel == 0){										// cpm
			disp_cph_save_data(0);							// ۑf[^iPԂƁj̕\
		}else if(sel == 1){									// cph
			disp_cph_save_data(1);							// ۑf[^iPԂƁj̕\
		}else{												// cpd
			disp_cph_save_data(2);							// ۑf[^iPƁj̕\
		}
	}
}
//*****************************************
// rddoqnlۑf[^̕\
//*****************************************
void	display_seep_save_data(void)
{
	unsigned char	j;
	unsigned int	i;
	unsigned char	end = 0;
	unsigned char	ssm;
	unsigned char	gpe;
	unsigned char	yuukou;
	char			*cp;

	disp_clear_lcd_G();									// Clear Display
	ssm = read_seep_save_mode();						// rddoqnlf[^ۑ[hrddoqnlǂݏo
	gpe = read_seep_gps_enable();						// rddoqnlf[^for[hrddoqnlǂݏo

	get_pgm_str(&str_save_data[0]);						// "No  cph  uSv/h"
	disp_lcd_G(1,0,disp_moji);							// \
	if(ssm == 1){										// PԂƃf[^(cpm)̎
		get_pgm_str(&str_cpm[0]);						// "cpm"
		disp_lcd_G(5,0,disp_moji);						// \
	}else if(ssm == 2){									// PԂƃf[^(cph)̎
		get_pgm_str(&str_cph[0]);						// "cph"
		disp_lcd_G(5,0,disp_moji);						// \
	}else if(ssm == 3){									// Pƃf[^(cpd)̎
		get_pgm_str(&str_cpd[0]);						// "cpd"
		disp_lcd_G(5,0,disp_moji);						// \
	}

	wait_sw_off();										// Q̃XCb`Q@܂ŉiv[v

	if((seep_write_pos == 0)||(ssm == 0)||(4 <= ssm)){	// ۑ
		get_pgm_str(&str_no_data[0]);					// vÖ̕("No Data !!")擾
		disp_lcd_G( 3,1,disp_moji);						// \
		delay_ms(4000);									// 4000mS Delay
	}else{												// ۑL鎞
		i = seep_write_pos;
		while(0 < i){
			if(gpe == 1){															// forf[^鎞
				get_pgm_str(&str_space10[0]);										// vÖ̕("      ")擾
				disp_lcd_G( 5, 0, &disp_moji[0]);									// display "          "(cpm   uSv/h )
				for(j= 0; j<2; j++){
					seep_read_64((i-1) * 64, (void *)(&lsep_dt[0]));					// ۑf[^̓ǂݏo

					get_pgm_str(&str_save_data[0]);										// "No  cph  uSv/h"
					disp_moji[4] = 0;
					disp_lcd_G(0, 0+j*4, &disp_moji[0]);								// display "No  "

					wtod_5u((char *)(&disp_moji[0]), (seep_write_pos - i)+1 );			// ԍ
					disp_moji[0]='-';
					if(disp_moji[3] == ' '){
						disp_moji[1] = disp_moji[4];
						disp_moji[2] = 0;
					}else if(disp_moji[2] == ' '){
						disp_moji[1] = disp_moji[3];
						disp_moji[2] = disp_moji[4];
						disp_moji[3] = 0;
					}else if(disp_moji[1] == ' '){
						disp_moji[1] = disp_moji[2];
						disp_moji[2] = disp_moji[3];
						disp_moji[3] = disp_moji[4];
						disp_moji[4] = 0;
					}else{
						;
					}
					disp_lcd_G(3, 0+j*4, &disp_moji[0]);								// display Number

					get_pgm_str(&str_gps_data[0]);										// "GPS Data"
					disp_moji[3]=0;
					disp_lcd_G(10, 0+j*4, &disp_moji[0]);								// display "GPS"
					disp_one_char_lcd_G(13,0+j*4, ':');									// display Dot Matrix LCD  ':'

					convert_display_date_time(lsep_dt[1]);								// unsigned long ̒l\pɕϊ
					disp_lcd_G(4,1+j*4,disp_moji);										// display Date & Time

					if(lsep_dt[0] == 0xffffffff){										// Non Count Data
						get_pgm_str(&str_5minus[0]);									// "-----"
						disp_lcd_G(0,2+j*4,&disp_moji[0]);								// \
						disp_lcd_G(5,2+j*4,&disp_moji[3]);								// \
						disp_lcd_G(0,3+j*4,&disp_moji[1]);								// \
					}else{
						wtod_7u((char *)disp_moji, lsep_dt[0]);							// JEg
						if(1000000 <= lsep_dt[0]){										// Vȏ̎
							disp_lcd_G(0, 2+j*4, &disp_moji[0]);						// display Count
						}else{															// Uȉ̎
							disp_lcd_G(0, 2+j*4, &disp_moji[1]);						// display Count
						}
						if(ssm == 1){													// PԂƃf[^(cpm)̎
							disp_uSv_at_count(0, 3+j*4, lsep_dt[0], 1, 0);				// rZ\iPԂ̃JEgɂj
							get_pgm_str(&str_cpm[0]);									// "cpm"
						}else if(ssm == 3){												// P̃f[^(cpd)̎
							disp_uSv_at_count(0, 3+j*4, lsep_dt[0]/(unsigned long)24, 0, 0);	// rZ\iPԂ̃JEgɂj
							get_pgm_str(&str_cpd[0]);									// "cpd"
						}else{															// PԖ̃f[^̎
							disp_uSv_at_count(0, 3+j*4, lsep_dt[0], 0, 0);				// rZ\iPԂ̃JEgɂj
							get_pgm_str(&str_cph[0]);									// "cph"
						}
						if(1000000 <= lsep_dt[0]){										// Vȏ̎
							disp_lcd_G(7,2+j*4,disp_moji);								// cpm/cph/cpd \
						}else{															// Uȉ̎
							disp_lcd_G(6,2+j*4,disp_moji);								// cpm/cph/cpd \
						}
						get_pgm_str(&str_save_data[0]);									// "No       uSv/h"
						disp_lcd_G(4,3+j*4,&disp_moji[9]);								// uSv/h \
					}
					cp = (char *)(&lsep_dt[2]);
					yuukou = get_gps_data_to_lsep_dt(cp);								// forf[^oď̏ꏊɃZbg
					disp_lcd_G(11, 2+j*4, gps_ido);										// ܓx
					disp_lcd_G(10, 3+j*4, gps_keido);									// ox
					if(yuukou == 1){
						disp_one_char_lcd_G(14,0+j*4, 'o');								// display Dot Matrix LCD  'o'
					}else{
						disp_one_char_lcd_G(14,0+j*4, 'x');								// display Dot Matrix LCD  'x'
					}
					i--;
					if(i == 0){															// ۑf[^Ō܂Ł@I
						end = 1;
						j++;
						get_pgm_str(&str_space10[0]);									// vÖ̕("      ")擾
						for(;j<2;j++){													// c蕔̕\NA
							disp_lcd_G( 0,0+j*4,disp_moji);
							disp_lcd_G(10,0+j*4,disp_moji);
							disp_lcd_G( 0,1+j*4,disp_moji);
							disp_lcd_G(10,1+j*4,disp_moji);
							disp_lcd_G( 0,2+j*4,disp_moji);
							disp_lcd_G(10,2+j*4,disp_moji);
							disp_lcd_G( 0,3+j*4,disp_moji);
							disp_lcd_G(10,3+j*4,disp_moji);
						}
						break;															// I
					}
				}
			}else{																		// forf[^
				for(j= 0; j<3; j++){
					seep_read_8((i-1) * 8, (void *)(&lsep_dt[0]));						// ۑf[^̓ǂݏo
					wtod_5u((char *)(&disp_moji[0]), (seep_write_pos - i)+1 );			// ԍ
					disp_moji[0]='-';
					if(disp_moji[3] == ' '){
						disp_moji[1] = disp_moji[4];
						disp_moji[2] = 0;
					}else if(disp_moji[2] == ' '){
						disp_moji[1] = disp_moji[3];
						disp_moji[2] = disp_moji[4];
						disp_moji[3] = 0;
					}else if(disp_moji[1] == ' '){
						disp_moji[1] = disp_moji[2];
						disp_moji[2] = disp_moji[3];
						disp_moji[3] = disp_moji[4];
						disp_moji[4] = 0;
					}else{
						;
					}
					disp_lcd_G(0, 1+j*2, &disp_moji[0]);								// display Number

					convert_display_date_time(lsep_dt[1]);								// unsigned long ̒l\pɕϊ
					disp_lcd_G(4,1+j*2,disp_moji);										// display Date & Time

					if(lsep_dt[0] == 0xffffffff){										// Non Count Data
						get_pgm_str(&str_5minus[0]);									// "-----"
						disp_lcd_G(2,2+j*2,&disp_moji[0]);								// \
						disp_lcd_G(7,2+j*2,&disp_moji[3]);								// \
						disp_lcd_G(11,2+j*2,&disp_moji[1]);								// \
					}else{
						wtod_7u((char *)disp_moji, lsep_dt[0]);							// JEg
						disp_lcd_G(2, 2+j*2, &disp_moji[0]);							// display Count
						if(ssm == 1){													// PԂƃf[^(cpm)̎
							disp_uSv_at_count(11, 2+j*2, lsep_dt[0], 1, 0);						// rZ\iPԂ̃JEgɂj
						}else if(ssm == 3){												// P̃f[^(cpd)̎
							disp_uSv_at_count(11, 2+j*2, lsep_dt[0]/(unsigned long)24, 0, 0);	// rZ\iPԂ̃JEgɂj
						}else{															// PԖ̃f[^̎
							disp_uSv_at_count(11, 2+j*2, lsep_dt[0], 0, 0);				// rZ\iPԂ̃JEgɂj
						}
					}
					i--;
					if(i == 0){															// ۑf[^Ō܂Ł@I
						end = 1;
						j++;
						get_pgm_str(&str_space10[0]);									// vÖ̕("      ")擾
						for(;j<3;j++){													// c蕔̕\NA
							disp_lcd_G( 0,1+j*2,disp_moji);
							disp_lcd_G(10,1+j*2,disp_moji);
							disp_lcd_G( 0,2+j*2,disp_moji);
							disp_lcd_G(10,2+j*2,disp_moji);
						}
						break;															// I
					}
				}
			}
			wait_sw_off();															// Q̃XCb`Q@܂ŉiv[v

			while(1){																// XCb`ꂽi܂ŉiv[vj
				if((PIND & SW_LEFT) == 0){
					delay_ms(50);													// 50mS Delay
					if((PIND & SW_LEFT) == 0){										// ̃XCb`{ɉꂽƂ
						break;														// ̃ubN̕\Ɉڂ
					}
				}else if((PIND & SW_RIGHT) == 0){
					delay_ms(100);													// 100mS Delay
					if((PIND & SW_RIGHT) == 0){										// ̃XCb`{ɉꂽƂ
						end = 1;
						break;														// ̃ubN\Ɂ@IɏIɂ
					}
				}
			}
			if(end == 1){
				break;
			}
		}
	}
}

//*****************************************
// ۑf[^̑I
//*****************************************
void	select_proc_save_data(void)
{
	unsigned char	sel=0;									//0:"Display Value", 1:"Display Graph", 2:"Tranmit", 3:"Delete"
	unsigned char	kesu=1;

	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_save_sel_proc[0]);					// vÖ̕("Select Process")擾
	disp_lcd_G( 0,0,disp_moji);							// \
	get_pgm_str(&str_for_save_date[0]);					// vÖ̕(" for Save Data")擾
	disp_lcd_G( 0,1,disp_moji);							// \

	get_pgm_str(&str_disp_vul[0]);						// "Display Value"
	disp_lcd_G( 0,2,disp_moji);							// \
	get_pgm_str(&str_disp_grh[0]);						// "Display Graph"
	disp_lcd_G( 0,3,disp_moji);							// \
	get_pgm_str(&str_transmit[0]);						// "Transmit"
	disp_lcd_G( 0,4,disp_moji);							// \
	get_pgm_str(&str_delete[0]);						// "Delete"
	disp_lcd_G( 0,5,disp_moji);							// \
	get_pgm_str(&str_display_seep_data[0]);				// "Display Seep Data"
	disp_lcd_G( 0,6,disp_moji);							// \
	get_pgm_str(&str_transmit_seep_data[0]);			// "Transmit Seep Data"
	disp_lcd_G( 0,7,disp_moji);							// \

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial
	read_hv_target_volt(0);								// gu@o͒l̓ǂݏo

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){												// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;

			kesu ^= 1;														// I̓_
			if(kesu == 0){													// _ł̓_̎
				get_pgm_str(&str_disp_vul[0]);								// "Display Value"
				disp_lcd_G( 0,2,disp_moji);									// \
				get_pgm_str(&str_disp_grh[0]);								// "Display Graph"
				disp_lcd_G( 0,3,disp_moji);									// \
				get_pgm_str(&str_transmit[0]);								// "Transmit"
				disp_lcd_G( 0,4,disp_moji);									// \
				get_pgm_str(&str_delete[0]);								// "Delete"
				disp_lcd_G( 0,5,disp_moji);									// \
				get_pgm_str(&str_display_seep_data[0]);						// "Display Seep Data"
				disp_lcd_G( 0,6,disp_moji);									// \
				get_pgm_str(&str_transmit_seep_data[0]);					// "Transmit Seep Data"
				disp_lcd_G( 0,7,disp_moji);									// \
			}else{															// _ł̖ł̎
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(sel == 0){
					disp_lcd_G(0,2, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(10,2, &disp_moji[7]);						// Xy[X\
				}else if(sel == 1){
					disp_lcd_G(0,3, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(10,3, &disp_moji[7]);						// Xy[X\
				}else if(sel == 2){
					disp_lcd_G(0,4, &disp_moji[0]);							// Xy[X\
				}else if(sel == 3){
					disp_lcd_G(0,5, &disp_moji[0]);							// Xy[X\
				}else if(sel == 4){
					disp_lcd_G(0,6, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(9,6, &disp_moji[0]);							// Xy[X\
				}else{
					disp_lcd_G(0,7, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(9,7, &disp_moji[0]);							// Xy[X\
				}
			}
		}
		get_sw();															//@XCb`Ԃ
		if(sw[2] != 0){														// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){										// XCb`
				sel++;
				if(5 < sel){
					sel = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){								// EXCb`
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(sel == 0){
					disp_lcd_G(0,3, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(10,3, &disp_moji[7]);						// Xy[X\
					disp_lcd_G(0,4, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,5, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,6, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(9,6, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,7, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(9,7, &disp_moji[0]);							// Xy[X\
					get_pgm_str(&str_disp_vul[0]);							// "Display Value"
					disp_lcd_G( 0,2,disp_moji);								// \
				}else if(sel == 1){
					disp_lcd_G(0,2, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(10,2, &disp_moji[7]);						// Xy[X\
					disp_lcd_G(0,4, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,5, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,6, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(9,6, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,7, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(9,7, &disp_moji[0]);							// Xy[X\
					get_pgm_str(&str_disp_grh[0]);							// "Display Graph"
					disp_lcd_G( 0,3,disp_moji);								// \
				}else if(sel == 2){
					disp_lcd_G(0,2, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(10,2, &disp_moji[7]);						// Xy[X\
					disp_lcd_G(0,3, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(10,3, &disp_moji[7]);						// Xy[X\
					disp_lcd_G(0,5, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,6, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(9,6, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,7, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(9,7, &disp_moji[0]);							// Xy[X\
					get_pgm_str(&str_transmit[0]);							// "Transmit"
					disp_lcd_G(0,4,disp_moji);								// \
				}else if(sel == 3){
					disp_lcd_G(0,2, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(10,2, &disp_moji[7]);						// Xy[X\
					disp_lcd_G(0,3, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(10,3, &disp_moji[7]);						// Xy[X\
					disp_lcd_G(0,4, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,6, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(9,6, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,7, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(9,7, &disp_moji[0]);							// Xy[X\
					get_pgm_str(&str_delete[0]);							// "Delete"
					disp_lcd_G(0,5,disp_moji);								// \
				}else if(sel == 4){
					disp_lcd_G(0,2, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(10,2, &disp_moji[7]);						// Xy[X\
					disp_lcd_G(0,3, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(10,3, &disp_moji[7]);						// Xy[X\
					disp_lcd_G(0,4, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,5,disp_moji);								// \
					disp_lcd_G(0,7, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(9,7, &disp_moji[0]);							// Xy[X\
					get_pgm_str(&str_display_seep_data[0]);					// "Display Seep Data"
					disp_lcd_G(0,6,disp_moji);								// \
				}else{
					disp_lcd_G(0,2, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(10,2, &disp_moji[7]);						// Xy[X\
					disp_lcd_G(0,3, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(10,3, &disp_moji[7]);						// Xy[X\
					disp_lcd_G(0,4, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(0,5,disp_moji);								// \
					disp_lcd_G(0,6, &disp_moji[0]);							// Xy[X\
					disp_lcd_G(9,6, &disp_moji[0]);							// Xy[X\
					get_pgm_str(&str_transmit_seep_data[0]);				// "Transmit Seep Data"
					disp_lcd_G(0,7,disp_moji);								// \
				}
				break;
			}
		}
	}
	wait_key_off();															// Q̃XCb`Q@܂ŉiv[v

	cli();

	if(sel <= 3){
		select_save_data(sel);
	}else if(sel == 4){
		display_seep_save_data();											// rddoqnlۑf[^̕\
	}else{
		transmit_seep_save_data();											// rddoqnlۑf[^̑M
	}
}
//*****************************************
// ۑf[^̕\
//*****************************************
void	proc_disp_save_data(void)
{
	if((PIND & (SW_LEFT | SW_RIGHT)) == SW_RIGHT){		// PIND0(Left SW) ݂̂nm
		delay_ms(100);									// 100mS Delay
		if((PIND & (SW_LEFT | SW_RIGHT)) == SW_RIGHT){	// PIND0(Left SW) ݂̂nm
			for(;;){
				select_proc_save_data();				// ۑf[^̑I
			}
		}
	}
}
